GLR_O = {}

local L = LibStub("AceLocale-3.0"):GetLocale("GuildLotteryRaffle")
local dialog = LibStub("AceConfigDialog-3.0")
local PlayerName = GetUnitName("PLAYER", false)
local _, _, classIndex = UnitClass("PLAYER")
local FullPlayerName = (GetUnitName("PLAYER", false) .. "-" .. string.gsub(string.gsub(GetRealmName(), "-", ""), "%s+", ""))
local CopyLotteryProfileName = 0
local CopyRaffleProfileName = 0
local CopyLotteryMessageProfileName = 0
local CopyRaffleMessageProfileName = 0
local CopyBothMessageProfileName = 0
local GLR_SelectLotteryTransferPlayer = 0
local GLR_SelectRaffleTransferPlayer = 0
local ConfirmTransferLotteryData = false
local ConfirmTransferRaffleData = false
local CopyLotteryProfileTable = {}
local CopyRaffleProfileTable = {}
local CopyLotteryMessageProfileTable = {}
local CopyRaffleMessageProfileTable = {}
local CopyBothMessageProfileTable = {}
local LotteryTransferTable = {}
local RaffleTransferTable = {}
local classColors = {
    [1] = "C79C6E", -- Warrior
    [2] = "F58CBA", -- Paladin
    [3] = "ABD473", -- Hunter
    [4] = "FFF569", -- Rogue
    [5] = "FFFFFF", -- Priest
    [6] = "C41F3B", -- Death Knight
    [7] = "0070DE", -- Shaman
    [8] = "69CCF0", -- Mage
    [9] = "9482C9", -- Warlock
    [10]  = "00FF96", -- Monk
    [11]  = "FF7D0A", -- Druid
    [12]  = "A330C9" -- Demon Hunter
}
local GiveawayConfirm = false
local GiveawayTickets = "0"
local GiveawaySelectEvent = 1
local GiveawaySelectEventName = { [1] = L["Lottery"], [2] = L["Raffle"] }
local GiveawayValueKey = 1
local GiveawayValueSelected = ""
local GiveawayValuesTable = {
	[1] = L["Giveaway - Everyone"],
	[2] = L["Giveaway - By Rank"]
}
local GiveawayLastOnlineTableKey = 0
local GiveawayLastOnlineTable = {
	[0] = L["Giveaway - Everyone"],
	[1] = L["Giveaway - Currently Online"],
	[2] = L["Giveaway - 7 Days"],
	[3] = L["Giveaway - 14 Days"],
	[4] = L["Giveaway - 21 Days"],
	[5] = L["Giveaway - 28 Days"],
}
GiveawayMultiGuildNames = { ["Alliance"] = {}, ["Horde"] = {}, }
local GiveawayMultiGuildKey = 1
local GiveawayMultiGuildName = ""
GiveawayMultiGuildRankTable = { ["Alliance"] = {}, ["Horde"] = {}, }
GiveawayMultiGuildRankSelectTable = { ["Alliance"] = {}, ["Horde"] = {}, }
local GiveawayMultiGuildFactionKey = 1
local GiveawayMultiGuildFactionTable = { [1] = "Alliance", [2] = "Horde" }
local GiveawayMultiGuildFaction = GiveawayMultiGuildFactionTable[GiveawayMultiGuildFactionKey]
GLR_EntryTable = { ["Alliance"] = {}, ["Horde"] = {}, }
GLR_EntryCheckTable = { ["Alliance"] = {}, ["Horde"] = {}, }
local GLR_FinalEntryTable = {}
local CheckMultiGuildFaction = false
local GLR_ConfirmCancelLottery = false
local GLR_ConfirmCancelRaffle = false
local ValidEntriesCount = 0
local GiveAwayProgress = 0
local GiveAwayTotal = 0
local GiveAwayName = ""
local GiveAwayNumber = 0
local GiveAwayText = L["Giveaway - Names Available"] .. ": " .. L["0"]
local ShowFormats = false
local ShowFormatNumber = 1
local PlayerInfo = glrHistory or {}
local CharacterInfo = glrCharacter or {}
local GivenTickets = 0

local profile = {
	frames = {
		outside = {
			bgFile = "Interface\\CHATFRAME\\CHATFRAMEBACKGROUND",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			edgeSize = 13,
			insets = {left = 2, right = 2, top = 2, bottom = 2},
		},
		inside = {
			bgFile = "Interface\\CHATFRAME\\CHATFRAMEBACKGROUND",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			edgeSize = 13,
			insets = {left = 2, right = 2, top = 2, bottom = 2},
		},
		dropdown = {
			bgFile = "Interface\\CHATFRAME\\CHATFRAMEBACKGROUND",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			edgeSize = 13,
			insets = {left = 2, right = 2, top = 2, bottom = 2},
		},
	},
	buttons = {
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true,
		tileSize = 4,
		edgeSize = 13,
		insets = {left = 2, right = 2, top = 2, bottom = 2},
	},
	colors = {
		frames = {
			outside = {
				bordercolor = {1, 0.87, 0, 1},
				bgcolor = {0, 0, 0, 0.5},
			},
			inside = {
				bordercolor = {1, 0.87, 0, 1},
				bgcolor = {0, 0, 0, 0.25},
			},
			dropdown = {
				bordercolor = {1, 0.87, 0, 1},
				bgcolor = {0, 0, 0, 1},
			},
		},
		buttons = {
			bordercolor = {1, 0.87, 0, 1},
			bgcolor = {0, 0, 0, 0.5},
		},
	},
}

local frame = CreateFrame("Frame", nil, UIParent)
frame:SetSize(350, 75)
frame:SetPoint("CENTER", UIParent)
frame:SetFrameStrata("DIALOG")
frame:SetMovable(false)
frame:SetResizable(false)
frame:SetBackdrop({
	bgFile = profile.frames.outside.bgFile,
	edgeFile = profile.frames.outside.edgeFile,
	edgeSize = profile.frames.outside.edgeSize,
	insets = profile.frames.outside.insets,
})
frame:SetBackdropColor(unpack(profile.colors.frames.outside.bgcolor))
frame:SetBackdropBorderColor(unpack(profile.colors.frames.outside.bordercolor))
frame:Hide()

local statusbar = CreateFrame("StatusBar", nil, frame)
statusbar:SetPoint("BOTTOM", frame, "BOTTOM", 0, 15)
statusbar:SetWidth(200)
statusbar:SetHeight(19)
statusbar:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar:GetStatusBarTexture():SetHorizTile(false)
statusbar:GetStatusBarTexture():SetVertTile(false)
statusbar:SetStatusBarColor(0, 0, 1)
statusbar:SetMinMaxValues(0, GiveAwayTotal)
statusbar:SetValue(GiveAwayProgress)
local _, statMax = statusbar:GetMinMaxValues()

local statusbar_bg = statusbar:CreateTexture(nil, "OVERLAY")
statusbar_bg:SetTexture("Interface\\UNITPOWERBARALT\\WowUI_Horizontal_Frame")
statusbar_bg:SetPoint("CENTER", statusbar, 0, 1)
statusbar_bg:SetSize(275, 52)

local statusbar_barbg = statusbar:CreateTexture(nil, "BACKGROUND")
statusbar_barbg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
statusbar_barbg:SetAllPoints(statusbar)
statusbar_barbg:SetHeight(20)
statusbar_barbg:SetVertexColor(0, 0, 0)

local statusbar_value = statusbar:CreateFontString(nil, "OVERLAY")
statusbar_value:SetPoint("CENTER", statusbar)
statusbar_value:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
statusbar_value:SetJustifyH("LEFT")
statusbar_value:SetShadowOffset(1, -1)
statusbar_value:SetTextColor(0, 1, 0)
statusbar_value:SetText(statusbar:GetValue() .. "%")

local statusbar_text = statusbar:CreateFontString(nil, "OVERLAY")
statusbar_text:SetPoint("TOPLEFT", frame, "TOPLEFT", 15, -13)
statusbar_text:SetFont("Fonts\\FRIZQT__.TTF", 16, "OUTLINE")
statusbar_text:SetJustifyH("LEFT")
statusbar_text:SetShadowOffset(1, -1)
statusbar_text:SetTextColor(1, 1, 1)
statusbar_text:SetText("Giving Tickets to: " .. GiveAwayName)

local function GenerateRosterNames()
	local t = {}
	local status = glrCharacter.Data.Settings.MultiGuild
	if glrRosterTotal == 0 then
		if not status then
			GLR_U:UpdateRosterTable()
		else
			GLR_U:PopulateMultiGuildTable()
		end
	end
	if not status then
		for i = 1, #glrRoster do
			local text = glrRoster[i]
			local playerName = string.sub(text, 1, string.find(text, '%[') - 1)
			local playerLevel = string.sub(text, string.find(text, '%(') + 1, string.find(text, '%)') - 1)
			playerName = strjoin(".", playerName, playerLevel)
			table.insert(t, playerName)
		end
	else
		for i = 1, #glrMultiGuildRoster do
			local text = glrMultiGuildRoster[i]
			local playerName = string.sub(text, 1, string.find(text, '%[') - 1)
			local playerLevel = string.sub(text, string.find(text, '%(') + 1, string.find(text, '%)') - 1)
			playerName = strjoin(".", playerName, playerLevel)
			table.insert(t, playerName)
		end
	end
	sort(t)
	return t
end

local function CommaValue(amount)
	local formatted = amount
	while true do
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
		if (k==0) then
			break
		end
	end
	return formatted
end

local function GetValue(value, EventType, NumberType, PlaceType)
	local total = value
	local event = EventType
	local NumberValue = NumberType
	local place = PlaceType
	local round = glrCharacter.Data.Settings.RoundJackpot
	if string.sub(total, string.find(total, "%.") + 1, string.find(total, "%.") + 1) == "" then
		total = tostring(total) .. "00"
		if string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 3) == "" then
			total = total .. "00"
		elseif string.sub(total, string.find(total, "%.") + 4, string.find(total, "%.") + 4) == "" then
			total = total .. "0"
		end
	elseif string.sub(total, string.find(total, "%.") + 2, string.find(total, "%.") + 2) == "" then
		total = tostring(total) .. "0"
		if string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 3) == "" then
			total = total .. "00"
		elseif string.sub(total, string.find(total, "%.") + 4, string.find(total, "%.") + 4) == "" then
			total = total .. "0"
		end
	elseif string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 3) == "" then
		total = tostring(total) .. "00"
	elseif string.sub(total, string.find(total, "%.") + 4, string.find(total, "%.") + 4) == "" then
		total = tostring(total) .. "0"
	end
	
	local Gold = string.sub(total, 1, string.find(total, "%.") - 1)
	local Silver = string.sub(total, string.find(total, "%.") + 1, string.find(total, "%.") + 2)
	local Copper = string.sub(total, string.find(total, "%.") + 3, string.find(total, "%.") + 4)
	
	if event == "Lottery" and NumberValue == "Jackpot" and round then
		Gold = tonumber(Gold)
		Silver = tonumber(Silver)
		Copper = tonumber(Copper)
		if Copper >= 50 then
			Copper = "00"
			Silver = Silver + 1
			if Silver >= 50 then
				Silver = "00"
				Gold = tostring(Gold + 1)
			else
				Silver = "00"
			end
		elseif Silver >= 50 then
			Copper = "00"
			Silver = "00"
			Gold = tostring(Gold + 1)
		else
			Copper = "00"
			Silver = "00"
		end
		if place then
			local startingGold = tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold)
			local tickets = glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold
			local price = tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice)
			local jackpotGold = startingGold + ( tickets * price )
			local TotalGold = GetValue(jackpotGold, "Lottery", "Jackpot", false)
			local check, _ = string.gsub(string.gsub(TotalGold, ",", ""), L["Value_Gold_Short"], "")
			if tonumber(string.sub(check, string.len(check), string.len(check))) >= 5 and tonumber(check) >= 12 then
				Gold = tostring(Gold + 1)
			else
				Gold = tostring(Gold)
			end
		else
			Gold = tostring(Gold)
		end
	end
	
	if tonumber(Copper) == 0 then
		if tonumber(Silver) == 0 then
			if tonumber(Gold) > 0 then
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"]
			else
				total = Gold .. L["Value_Gold_Short"] .. " " .. Silver .. L["Value_Silver_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			end
		else
			if tonumber(Gold) == 0 then
				total = Silver .. L["Value_Silver_Short"]
			else
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"] .. " " .. Silver .. L["Value_Silver_Short"]
			end
		end
	else
		if tonumber(Silver) == 0 then
			if tonumber(Gold) == 0 then
				total = Copper .. L["Value_Copper_Short"]
			else
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			end
		else
			if tonumber(Gold) == 0 then
				total = Silver .. L["Value_Silver_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			else
				Gold = CommaValue(Gold)
				total = Gold .. L["Value_Gold_Short"] .. " " .. Silver .. L["Value_Silver_Short"] .. " " .. Copper .. L["Value_Copper_Short"]
			end
		end
	end
	return total
end

local function GetMultiGuildList()
	local cross = glrCharacter.Data.Settings.CrossFactionEvents
	local faction, _ = UnitFactionGroup("PLAYER")
	local guild, _, _, _ = GetGuildInfo("PLAYER")
	local t = {}
	for f, tf in pairs(glrHistory.GuildStatus) do
		local continue = true
		if not cross and tostring(f) ~= faction then continue = false end
		if continue then
			local c = 1
			for g, tg in pairs(glrHistory.GuildStatus[f]) do
				continue = false
				if glrCharacter.Data.Settings.MultiGuild then
					if glrHistory.GuildStatus[f][g] then
						continue = true
					end
				elseif g == guild then
					continue = true
				end
				if continue then
					if GiveawayMultiGuildNames[f] == nil then GiveawayMultiGuildNames[f] = {} end
					for i = 1, #GiveawayMultiGuildNames[f] do
						if GiveawayMultiGuildNames[f][i] == g then
							continue = false
							break
						end
					end
					if continue then
						GiveawayMultiGuildNames[f][c] = g
						c = c + 1
					end
				end
			end
		end
	end
	sort(GiveawayMultiGuildNames)
	t = GiveawayMultiGuildNames
	return t
end

local function GetMultiGuildTables()
	local name = GetMultiGuildList()
	for f, tf in pairs(glrHistory.GuildRanks) do
		for j = 1, #name[f] do c = 0
			local use = name[f][j]
			if glrHistory.GuildRanks[f][use] ~= nil then
				for i = 1, #glrHistory.GuildRanks[f][use] do
					local c = 0
					if GiveawayMultiGuildRankTable[f] == nil then GiveawayMultiGuildRankTable[f] = {} end
					if GiveawayMultiGuildRankTable[f][use] == nil then
						GiveawayMultiGuildRankTable[f][use] = {}
						GLR_EntryTable[f][use] = {}
						GLR_EntryCheckTable[f][use] = {}
					end
					if GiveawayMultiGuildRankTable[f][use][i] == nil then
						GLR_EntryTable[f][use][glrHistory.GuildRanks[f][use][i]] = { ["Count"] = 0, ["State"] = false, ["Names"] = {}, }
						GLR_EntryCheckTable[f][use][glrHistory.GuildRanks[f][use][i]] = { ["State"] = false, ["Check"] = false, ["Entered"] = false, }
						for n = 1, #glrHistory.GuildRoster[f][use] do
							local player_rank = string.sub(glrHistory.GuildRoster[f][use][n], string.find(glrHistory.GuildRoster[f][use][n], "%|") + 1, string.find(glrHistory.GuildRoster[f][use][n], "%}") - 1)
							if player_rank == glrHistory.GuildRanks[f][use][i] then
								table.insert(GLR_EntryTable[f][use][glrHistory.GuildRanks[f][use][i]].Names, glrHistory.GuildRoster[f][use][n])
								c = c + 1
							end
						end
						GLR_EntryTable[f][use][glrHistory.GuildRanks[f][use][i]].Count = c
						GiveawayMultiGuildRankTable[f][use][i] = glrHistory.GuildRanks[f][use][i]
						if GiveawayMultiGuildRankSelectTable[f] == nil then GiveawayMultiGuildRankSelectTable[f] = {} end
						if GiveawayMultiGuildRankSelectTable[f][use] == nil then
							GiveawayMultiGuildRankSelectTable[f][use] = {}
						end
						GiveawayMultiGuildRankSelectTable[f][use][i] = false
					end
				end
			end
		end
	end
end

local function PreformGiveTickets(PlayerName, state, MaxTicket, dateTime, guaranteedWinner, PlayerTickets)
	
	local user = PlayerName
	if string.find(user, "%-") ~= nil then
		user = string.sub(user, 1, string.find(user, "%-") - 1)
	end
	statusbar_text:SetText("Giving Tickets to: " .. user)
	
	local FirstTicketNumberBought = true
	local LastTicketNumberBought = true
	
	if glrCharacter[state] == nil then
		glrCharacter[state] = {}
	end
	if glrCharacter[state].Entries == nil then
		glrCharacter[state].Entries = {}
	end
	if glrCharacter[state].Entries.TicketRange == nil then
		glrCharacter[state].Entries.TicketRange = {}
	end
	if glrCharacter[state].Entries.TicketRange[PlayerName] == nil then
		glrCharacter[state].Entries.TicketRange[PlayerName] = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
	end
	
	if glrTemp[state][PlayerName] == nil then
		glrTemp[state][PlayerName] = {}
	end
	if glrTemp[state][PlayerName].TicketNumbers == nil then
		glrTemp[state][PlayerName].TicketNumbers = {}
	end
	if glrCharacter[state].Entries.TicketNumbers[PlayerName] ~= nil then
		glrTemp[state][PlayerName] = glrCharacter[state].Entries.TicketNumbers[PlayerName]
		glrTemp[state][PlayerName].NumberOfTickets = glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets
		glrTemp[state][PlayerName].TicketNumbers = glrCharacter[state].Entries.TicketNumbers[PlayerName]
	end
	if glrTemp[state][PlayerName].NumberOfTickets == nil then
		glrTemp[state][PlayerName].NumberOfTickets = {}
	end
	if glrTemp[state][PlayerName].TicketRange == nil then
		glrTemp[state][PlayerName].TicketRange = { ["LowestTicketNumber"] = 0, ["HighestTicketNumber"] = 0 }
	end
	
	if glrCharacter[state].Entries.Tickets[PlayerName] == nil then
		
		glrCharacter[state].Entries.Tickets[PlayerName] = {}
		glrCharacter[state].Entries.Tickets[PlayerName].Sold = 0
		glrCharacter[state].Entries.Tickets[PlayerName].Given = PlayerTickets
		glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets = {}
		glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets = PlayerTickets
		glrTemp[state][PlayerName].NumberOfTickets = PlayerTickets
		
		table.insert(glrCharacter[state].Entries.Names, PlayerName)
		
		if glrCharacter[state].Entries.TicketNumbers[PlayerName] == nil then
			
			local TicketNumber = glrCharacter.Event[state].LastTicketBought
			
			glrCharacter[state].Entries.TicketNumbers[PlayerName] = {}
			
			if glrCharacter[state].TicketPool[1] ~= nil then
				
				for i = 1, PlayerTickets do
					GivenTickets = GivenTickets + 1
					if glrCharacter[state].TicketPool[1] ~= nil then
						
						table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], glrCharacter[state].TicketPool[1])
						table.insert(glrTemp[state][PlayerName].TicketNumbers, glrCharacter[state].TicketPool[1])
						if FirstTicketNumberBought then
							glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
							glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
							FirstTicketNumberBought = false
						end
						if PlayerTickets == i and LastTicketNumberBought then
							glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
							glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
							LastTicketNumberBought = false
						end
						table.remove(glrCharacter[state].TicketPool, 1)
						
					else
						
						if TicketNumber == 1000 or TicketNumber == 2000 or TicketNumber == 3000 or TicketNumber == 4000 or TicketNumber == 5000 or TicketNumber == 6000 or TicketNumber == 7000 or TicketNumber == 8000 or TicketNumber == 9000 then
							local TicketString = tostring(TicketNumber)
							table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
							table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
							if FirstTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
								FirstTicketNumberBought = false
							end
							if PlayerTickets == i and LastTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
								LastTicketNumberBought = false
							end
							if guaranteedWinner then
								TicketNumber = TicketNumber + 1
							else
								TicketNumber = TicketNumber + 2
							end
							glrCharacter.Event[state].LastTicketBought = TicketNumber
						else
							local TicketString = tostring(TicketNumber)
							table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
							table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
							if FirstTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
								FirstTicketNumberBought = false
							end
							if PlayerTickets == i and LastTicketNumberBought then
								glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
								glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
								LastTicketNumberBought = false
							end
							if guaranteedWinner then
								glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
								TicketNumber = TicketNumber + 1
							else
								glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
								TicketNumber = TicketNumber + 2
							end
						end
						
					end
					
				end
				
				if glrCharacter[state].TicketPool[1] ~= nil then
					sort(glrCharacter[state].TicketPool)
				end
				
			else
				
				for i = 1, PlayerTickets do
					GivenTickets = GivenTickets + 1
					if TicketNumber == 1000 or TicketNumber == 2000 or TicketNumber == 3000 or TicketNumber == 4000 or TicketNumber == 5000 or TicketNumber == 6000 or TicketNumber == 7000 or TicketNumber == 8000 or TicketNumber == 9000 then
						local TicketString = tostring(TicketNumber)
						table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
						table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
						if FirstTicketNumberBought then
							glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
							glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
							FirstTicketNumberBought = false
						end
						if PlayerTickets == i and LastTicketNumberBought then
							glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
							glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
							LastTicketNumberBought = false
						end
						if guaranteedWinner then
							TicketNumber = TicketNumber + 1
						else
							TicketNumber = TicketNumber + 2
						end
						glrCharacter.Event[state].LastTicketBought = TicketNumber
					else
						local TicketString = tostring(TicketNumber)
						table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], TicketString)
						table.insert(glrTemp[state][PlayerName].TicketNumbers, TicketString)
						if FirstTicketNumberBought then
							glrCharacter[state].Entries.TicketRange[PlayerName].LowestTicketNumber = TicketNumber
							glrTemp[state][PlayerName].TicketRange.LowestTicketNumber = TicketNumber
							FirstTicketNumberBought = false
						end
						if PlayerTickets == i and LastTicketNumberBought then
							glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
							glrTemp[state][PlayerName].TicketRange.HighestTicketNumber = TicketNumber
							LastTicketNumberBought = false
						end
						if guaranteedWinner then
							glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
							TicketNumber = TicketNumber + 1
						else
							glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
							TicketNumber = TicketNumber + 2
						end
					end
					
				end
				
			end
			
			if glrCharacter[state].MessageStatus == nil then
				glrCharacter[state].MessageStatus = {}
			end
			if glrCharacter[state].MessageStatus[PlayerName] == nil then
				glrCharacter[state].MessageStatus[PlayerName] = { ["sentMessage"] = true, ["lastAlert"] = dateTime }
			end
			
		end
		
	else
		
		local currentTickets = glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets
		local MaxTicket = tonumber(glrCharacter.Event[state].MaxTickets)
		local ticketChange = PlayerTickets + currentTickets
		local TicketNumber = glrCharacter.Event[state].LastTicketBought
		local holdTickets = {}
		
		if ticketChange > MaxTicket then
			ticketChange = MaxTicket
		end
		
		local ticketIncrease = ticketChange - currentTickets
		
		for i = 1, #glrTemp[state][PlayerName].TicketNumbers do
			
			local v = glrTemp[state][PlayerName].TicketNumbers[i]
			table.insert(holdTickets, v)
			
		end
		
		glrCharacter[state].Entries.TicketNumbers[PlayerName] = nil
		glrCharacter[state].Entries.TicketNumbers[PlayerName] = {}
		
		for i = 1, currentTickets do
			
			table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], holdTickets[1])
			table.remove(holdTickets, 1)
			
		end
		
		for i = 1, ticketIncrease do
			GivenTickets = GivenTickets + 1
			if glrCharacter[state].TicketPool[1] ~= nil then
				
				table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], glrCharacter[state].TicketPool[1])
				table.insert(glrTemp[state][PlayerName], glrCharacter[state].TicketPool[1])
				if ticketIncrease == i and LastTicketNumberBought then
					glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = tonumber(glrCharacter[state].TicketPool[1])
					LastTicketNumberBought = false
				end
				table.remove(glrCharacter[state].TicketPool, 1)
				
			else
				
				local ts = tostring(TicketNumber)
				table.insert(glrCharacter[state].Entries.TicketNumbers[PlayerName], ts)
				table.insert(glrTemp[state][PlayerName], ts)
				if ticketIncrease == i and LastTicketNumberBought then
					glrCharacter[state].Entries.TicketRange[PlayerName].HighestTicketNumber = TicketNumber
					LastTicketNumberBought = false
				end
				if guaranteedWinner then
					glrCharacter.Event[state].LastTicketBought = TicketNumber + 1
					TicketNumber = TicketNumber + 1
				else
					glrCharacter.Event[state].LastTicketBought = TicketNumber + 2
					TicketNumber = TicketNumber + 2
				end
				
			end
			
		end
		
		sort(glrCharacter[state].TicketPool)
		sort(glrCharacter[state].Entries.TicketNumbers[PlayerName])
		
		glrCharacter[state].Entries.Tickets[PlayerName].NumberOfTickets = ticketChange
		glrCharacter[state].Entries.Tickets[PlayerName].Given = ticketChange
		glrTemp[state][PlayerName].NumberOfTickets = ticketChange
		
		if glrCharacter[state].MessageStatus[PlayerName] == nil then
			
			if glrCharacter[state].MessageStatus == nil then
				glrCharacter[state].MessageStatus = {}
			end
			if glrCharacter[state].MessageStatus[PlayerName] == nil then
				glrCharacter[state].MessageStatus[PlayerName] = { ["sentMessage"] = true, ["lastAlert"] = dateTime }
			end
			
		end
		
	end
	
	GiveAwayProgress = GiveAwayProgress + 1
	
	statusbar:SetValue(GiveAwayProgress)
	local statVal = floor(statusbar:GetValue() / statMax * 100)
	statusbar_value:SetText(statVal .. "%")
	
	if GiveAwayProgress == GiveAwayTotal then
		C_Timer.After(1, function(self) statusbar_value:SetText("Finalizing...") end)
		C_Timer.After(1.5, function(self) statusbar_value:SetText("Finalizing.") end)
		C_Timer.After(2, function(self) statusbar_value:SetText("Finalizing..") end)
		C_Timer.After(2.5, function(self) statusbar_value:SetText("Finalizing...") end)
		C_Timer.After(3, function(self) statusbar_value:SetText("Finalizing.") end)
		C_Timer.After(3.5, function(self) statusbar_value:SetText("Finalizing..") end)
		C_Timer.After(4, function(self) statusbar_value:SetText("Finalizing...") GLR_U:UpdateInfo() end)
		C_Timer.After(5, function(self) statusbar_value:SetText("Finished.") end)
		if glrCharacter.Event[state].GiveAwayTickets == nil then
			glrCharacter.Event[state].GiveAwayTickets = GivenTickets
		else
			glrCharacter.Event[state].GiveAwayTickets = glrCharacter.Event[state].GiveAwayTickets + GivenTickets
		end
		C_Timer.After(7.5, function(self) frame:Hide() end)
	end
	
end

local function GiveEveryoneTickets(GiveTickets, state)
	
	local faction, _ = UnitFactionGroup("PLAYER")
	local status = glrCharacter.Data.Settings.MultiGuild
	local PlayerNamesTable = GenerateRosterNames()
	local PlayerTickets = tonumber(GiveTickets)
	local MaxTicket = tonumber(glrCharacter.Event[state].MaxTickets)
	local dateTime = time()
	local guaranteedWinner = false
	GivenTickets = 0
	GiveAwayProgress = 0
	
	statusbar:SetMinMaxValues(0, GiveAwayTotal)
	_, statMax = statusbar:GetMinMaxValues()
	frame:Show()
	
	if state == "Lottery" then
		if glrCharacter.Event[state].SecondPlace == L["Winner Guaranteed"] then
			guaranteedWinner = true
		end
	else
		guaranteedWinner = true
	end
	
	if glrTemp == nil then
		glrTemp = {}
	end
	if glrTemp[state] == nil then
		glrTemp[state] = {}
	end
	
	local message = string.gsub(string.gsub(L["Ticket Giveaway"], "%%PlayerTickets", tostring(PlayerTickets)), "%%name", L[state])
	
	if PlayerTickets == 1 then
		message = string.gsub(message, "%%word", L["Ticket Giveaway Singular"])
	else
		message = string.gsub(message, "%%word", L["Ticket Giveaway Plural"])
	end
	
	if GiveawayValueKey == 2 then
		local steps = 10
		local ms = 0.25
		local done = false
		local RankList = {}
		local lt = {}
		local ts = ""
		
		C_Timer.After(ms, function(self) SendChatMessage(L["Send Info GLR"] .. ": " .. L["Ticket Giveaway Rank Based"], "GUILD") end)
		
		for f, tf in pairs(GLR_EntryTable) do
			for g, tg in pairs(GLR_EntryTable[f]) do
				for r, tr in pairs(GLR_EntryTable[f][g]) do
					if GLR_EntryTable[f][g][r].State then
						if RankList[r] == nil then
							table.insert(RankList, r)
						end
					end
				end
			end
		end
		
		sort(RankList)
		
		for i = 1, #RankList do --Recursive loop to search if multiple instances of the same Rank exist, and remove one of them. No break point in case more than two copies exist.
			for j = i + 1, #RankList do
				if RankList[i] == RankList[j] then
					table.remove(RankList, j)
				end
			end
		end
		
		for i = 1, #RankList do
			
			ts = RankList[1]
			table.remove(RankList, 1)
			
			for j = 1, steps do
				if not done then
					if RankList[1] == nil then
						break
					end
					if RankList[2] == nil then
						ts = strjoin(", & ", ts, RankList[1] .. ".")
						table.remove(RankList, 1)
					else
						ts = strjoin(", ", ts, RankList[1])
						table.remove(RankList, 1)
					end
				end
			end
			
			if not done then
				table.insert(lt, ts)
				ts = ""
			end
			
			if RankList[1] == nil then
				done = true
				break
			end
			
		end
		
		for i = 1, #lt do
			if lt[1] ~= nil then
				ms = ms + 0.25
				local msg = lt[1]
				C_Timer.After(ms, function(self) SendChatMessage("GLR: " .. msg, "GUILD") end)
				table.remove(lt, 1)
			end
		end
		
	end
	
	SendChatMessage(L["Send Info GLR"] .. ": " .. message, "GUILD")
	
	--local timer = 0.01
	--local div = 30
	local div = GiveAwayTotal / 20
	local timer = div / GiveAwayTotal
	
	--if GiveAwayTotal <= 100 then
		--div = 10
		--timer = div / GiveAwayTotal
	--end
	
	for i = 1, #GLR_FinalEntryTable do
		
		local PlayerName = GLR_FinalEntryTable[i]
		C_Timer.After(timer, function(self)
			PreformGiveTickets(PlayerName, state, MaxTicket, dateTime, guaranteedWinner, PlayerTickets)
		end)
		--timer = timer + 0.01
		timer = timer + ( div / GiveAwayTotal )
		
	end
	
end

local function GetTimeSinceLastLogin(UserTime)
	local days = math.floor((time() - UserTime)/86400)
	local check = 0
	if not glrCharacter.Data.Settings.MultiGuild then check = 1 end
	if GiveawayLastOnlineTableKey == (1 + check) and days <= 7 then
		return true
	elseif GiveawayLastOnlineTableKey == (2 + check) and days <= 14 then
		return true
	elseif GiveawayLastOnlineTableKey == (3 + check) and days <= 21 then
		return true
	elseif GiveawayLastOnlineTableKey == (4 + check) and days <= 28 then
		return true
	else
		return false
	end
end

local function GetTimeSinceLastLoginString(DateString)
	if string.find(DateString, "Online") then return true end
	local Years = tonumber(string.sub(DateString, 1, string.find(DateString, 'Y') - 1))
	local Months = tonumber(string.sub(DateString, string.find(DateString, 'Y') + 1, string.find(DateString, 'M') - 1))
	local Days = tonumber(string.sub(DateString, string.find(DateString, 'M') + 1, string.find(DateString, 'D') - 1))
	if Years == nil or Months == nil then return false end
	if Years >= 1 or Months >= 1 then return false end
	local check = 0
	if not glrCharacter.Data.Settings.MultiGuild then check = 1 end
	if GiveawayLastOnlineTableKey == (1 + check) and Days <= 7 then
		return true
	elseif GiveawayLastOnlineTableKey == (2 + check) and Days <= 14 then
		return true
	elseif GiveawayLastOnlineTableKey == (3 + check) and Days <= 21 then
		return true
	elseif GiveawayLastOnlineTableKey == (4 + check) and Days <= 28 then
		return true
	else
		return false
	end
end

local function PreviewMessage(message, state)
	local chatColor = string.format("%02X", ChatTypeInfo["GUILD"].r * 255) .. string.format("%02X", ChatTypeInfo["GUILD"].g * 255) .. string.format("%02X", ChatTypeInfo["GUILD"].b * 255)
	local showTimestamps = GetCVar("showTimestamps")
	local DateTime = ""
	local UserName = "[Guild] [|r|cFF" .. classColors[classIndex] .. PlayerName .. "|r|cFF" .. chatColor .. "]: "
	if showTimestamps ~= "none" then
		DateTime = date(showTimestamps)
	end
	message = string.gsub(message, "%%lottery_reply", L["Detect Lottery"])
	message = string.gsub(message, "%%raffle_reply", L["Detect Raffle"])
	message = string.gsub(message, "%%version", GLR_Version)
	if state == "Lottery" or state == "Both" then
		if glrCharacter.Data.Settings.CurrentlyActiveLottery then
			local gold = tostring( ( (tonumber(glrCharacter.Event.Lottery.StartingGold) + tonumber(glrCharacter.Event.Lottery.TicketPrice) * tonumber(glrCharacter.Event.Lottery.TicketsSold) ) - ( ( tonumber(glrCharacter.Event.Lottery.StartingGold) + tonumber(glrCharacter.Event.Lottery.TicketPrice) *  tonumber(glrCharacter.Event.Lottery.TicketsSold) ) * ( tonumber(glrCharacter.Event.Lottery.GuildCut) / 100 ) ) ) )
			local tickets = tostring(glrCharacter.Event.Lottery.TicketsSold)
			local PreviousWinner = ""
			local PreviousValue = ""
			if glrCharacter.PreviousEvent.Lottery.Available then
				local doBreak = false
				local WinStatus = glrCharacter.PreviousEvent.Lottery.Settings.WonType
				local PreviousJackpot = tostring( ( tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) ) - ( ( tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) ) * ( tonumber(glrCharacter.PreviousEvent.Lottery.Settings.GuildCut) / 100 ) ) )
				if not WinStatus then
					PreviousJackpot = tostring(tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) - (tonumber(glrCharacter.PreviousEvent.Lottery.Settings.StartingGold) + tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketPrice) * tonumber(glrCharacter.PreviousEvent.Lottery.Settings.TicketsSold) * (tonumber(glrCharacter.PreviousEvent[ExportType].Settings.SecondPlace) / 100)))
				end
				PreviousValue = GetValue(PreviousJackpot, "Lottery", "Jackpot", PreviousRound)
				for i = 1, #glrCharacter.PreviousEvent.Lottery.Data.Entries.Names do
					name = glrCharacter.PreviousEvent.Lottery.Data.Entries.Names[i]
					for j = 1, #glrCharacter.PreviousEvent.Lottery.Data.Entries.TicketNumbers[name] do
						if glrCharacter.PreviousEvent.Lottery.Data.Entries.TicketNumbers[name][j] == glrCharacter.PreviousEvent.Lottery.Data.Winner then
							local PreviousRound = glrCharacter.PreviousEvent.Lottery.Settings.RoundJackpot
							PreviousWinner = name
							doBreak = true
							break
						end
					end
					if doBreak then break end
				end
				if not doBreak then PreviousWinner = "No Winner!" end
			else
				PreviousWinner = "No Winner!"
				PreviousValue = "0g"
			end
			message = string.gsub(message, "%%previous_winner", PreviousWinner)
			message = string.gsub(message, "%%previous_jackpot", PreviousValue)
			if string.find(glrCharacter.Event.Lottery.TicketPrice, "%.") == nil then
				message = string.gsub(message, "%%lottery_price", glrCharacter.Event.Lottery.TicketPrice)
			else
				local TicketGold = string.sub(glrCharacter.Event.Lottery.TicketPrice, 1, string.find(glrCharacter.Event.Lottery.TicketPrice, "%.") - 1)
				local TicketSilver = string.sub(glrCharacter.Event.Lottery.TicketPrice, string.find(glrCharacter.Event.Lottery.TicketPrice, "%.") + 1, string.find(glrCharacter.Event.Lottery.TicketPrice, "%.") + 2)
				local TicketCopper = string.sub(glrCharacter.Event.Lottery.TicketPrice, string.find(glrCharacter.Event.Lottery.TicketPrice, "%.") + 3)
				local TicketMessageString = ""
				if tonumber(TicketCopper) == 0 then
					if tonumber(TicketSilver) == 0 then
						if tonumber(TicketGold) > 0 then
							TicketMessageString = TicketGold .. L["Value_Gold_Short"]
						end
					else
						if tonumber(TicketGold) == 0 then
							TicketMessageString = TicketSilver .. L["Value_Silver"]
						else
							TicketMessageString = TicketGold .. L["Value_Gold_Short"] .. " " .. TicketSilver .. L["Value_Silver_Short"]
						end
					end
				else
					if tonumber(TicketSilver) == 0 then
						if tonumber(TicketGold) == 0 then
							TicketMessageString = TicketCopper .. L["Value_Copper_Short"]
						else
							TicketMessageString = TicketGold .. L["Value_Gold_Short"] .. " " .. TicketCopper .. L["Value_Copper_Short"]
						end
					else
						if tonumber(TicketGold) == 0 then
							TicketMessageString = TicketSilver .. L["Value_Silver_Short"] .. " " .. TicketCopper .. L["Value_Copper_Short"]
						else
							TicketMessageString = TicketGold .. L["Value_Gold_Short"] .. " " .. TicketSilver .. L["Value_Silver_Short"] .. " " .. TicketCopper .. L["Value_Copper_Short"]
						end
					end
				end
				message = string.gsub(message, "%%lottery_price", TicketMessageString)
			end
			message = string.gsub(message, "%%lottery_max", glrCharacter.Event.Lottery.MaxTickets)
			message = string.gsub(message, "%%lottery_name", glrCharacter.Event.Lottery.EventName)
			message = string.gsub(message, "%%lottery_date", glrCharacter.Event.Lottery.Date)
			if gold ~= nil then
				if string.find(gold, "%.") == nil then
					message = string.gsub(message, "%%lottery_gold", gold)
				else
					local JackpotGold = string.sub(gold, 1, string.find(gold, "%.") - 1)
					local JackpotSilver = string.sub(gold, string.find(gold, "%.") + 1, string.find(gold, "%.") + 2)
					local JackpotCopper = string.sub(gold, string.find(gold, "%.") + 3)
					local JackpotMessageString = ""
					if tonumber(JackpotCopper) == 0 then
						if tonumber(JackpotSilver) == 0 then
							if tonumber(JackpotGold) > 0 then
								JackpotMessageString = JackpotGold .. L["Value_Gold_Short"]
							end
						else
							if tonumber(JackpotGold) == 0 then
								JackpotMessageString = JackpotSilver .. L["Value_Silver_Short"]
							else
								JackpotMessageString = JackpotGold .. L["Value_Gold_Short"] .. " " .. JackpotSilver .. L["Value_Silver_Short"]
							end
						end
					else
						if tonumber(JackpotSilver) == 0 then
							if tonumber(JackpotGold) == 0 then
								JackpotMessageString = JackpotCopper .. L["Value_Copper_Short"]
							else
								JackpotMessageString = JackpotGold .. L["Value_Gold_Short"] .. " " .. JackpotCopper .. L["Value_Copper_Short"]
							end
						else
							if tonumber(JackpotGold) == 0 then
								JackpotMessageString = JackpotSilver .. L["Value_Silver_Short"] .. " " .. JackpotCopper .. L["Value_Copper_Short"]
							else
								JackpotMessageString = JackpotGold .. L["Value_Gold_Short"] .. " " .. JackpotSilver .. L["Value_Silver_Short"] .. " " .. JackpotCopper .. L["Value_Copper_Short"]
							end
						end
					end
					message = string.gsub(message, "%%lottery_gold", JackpotMessageString)
				end
			end
			if tickets ~= nil then
				message = string.gsub(message, "%%lottery_tickets", tickets)
			end
			if string.len(message) > 255 then
				message = L["Configuration Panel Message Too Long"]
			end
		end
	end
	if state == "Raffle" or state == "Both" then
		if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
			local gold = tostring(glrCharacter.Event.Raffle.TicketsSold * tonumber(glrCharacter.Event.Raffle.TicketPrice))
			local tickets = tostring(glrCharacter.Event.Raffle.TicketsSold)
			local prizes = glrCharacter.Event.Raffle.FirstPlace
			if glrCharacter.Event.Raffle.SecondPlace ~= false then
				prizes = prizes .. ", " .. glrCharacter.Event.Raffle.SecondPlace
			end
			if glrCharacter.Event.Raffle.ThirdPlace ~= false then
				prizes = prizes .. ", " .. glrCharacter.Event.Raffle.ThirdPlace
			end
			if string.find(glrCharacter.Event.Raffle.TicketPrice, "%.") == nil then
				message = string.gsub(message, "%%raffle_price", glrCharacter.Event.Raffle.TicketPrice)
			else
				local TicketGold = string.sub(glrCharacter.Event.Raffle.TicketPrice, 1, string.find(glrCharacter.Event.Raffle.TicketPrice, "%.") - 1)
				local TicketSilver = string.sub(glrCharacter.Event.Raffle.TicketPrice, string.find(glrCharacter.Event.Raffle.TicketPrice, "%.") + 1, string.find(glrCharacter.Event.Raffle.TicketPrice, "%.") + 2)
				local TicketCopper = string.sub(glrCharacter.Event.Raffle.TicketPrice, string.find(glrCharacter.Event.Raffle.TicketPrice, "%.") + 3)
				local TicketMessageString = ""
				if tonumber(TicketCopper) == 0 then
					if tonumber(TicketSilver) == 0 then
						if tonumber(TicketGold) > 0 then
							TicketMessageString = TicketGold .. " " .. L["Value_Gold"]
						end
					else
						if tonumber(TicketGold) == 0 then
							TicketMessageString = TicketSilver .. " " .. L["Value_Silver"]
						else
							TicketMessageString = TicketGold .. " " .. L["Value_Gold"] .. " " .. TicketSilver .. " " .. L["Value_Silver"]
						end
					end
				else
					if tonumber(TicketSilver) == 0 then
						if tonumber(TicketGold) == 0 then
							TicketMessageString = TicketCopper .. " " .. L["Value_Copper"]
						else
							TicketMessageString = TicketGold .. " " .. L["Value_Gold"] .. " " .. TicketCopper .. " " .. L["Value_Copper"]
						end
					else
						if tonumber(TicketGold) == 0 then
							TicketMessageString = TicketSilver .. " " .. L["Value_Silver"] .. " " .. TicketCopper .. " " .. L["Value_Copper"]
						else
							TicketMessageString = TicketGold .. " " .. L["Value_Gold"] .. " " .. TicketSilver .. " " .. L["Value_Silver"] .. " " .. TicketCopper .. " " .. L["Value_Copper"]
						end
					end
				end
				message = string.gsub(message, "%%raffle_price", TicketMessageString)
			end
			message = string.gsub(message, "%%raffle_max", glrCharacter.Event.Raffle.MaxTickets)
			message = string.gsub(message, "%%raffle_name", glrCharacter.Event.Raffle.EventName)
			message = string.gsub(message, "%%raffle_date", glrCharacter.Event.Raffle.Date)
			message = string.gsub(message, "%%raffle_prizes", prizes)
			if gold ~= nil then
				if string.find(gold, "%.") == nil then
					message = string.gsub(message, "%%raffle_gold", gold)
				else
					local JackpotGold = string.sub(gold, 1, string.find(gold, "%.") - 1)
					local JackpotSilver = string.sub(gold, string.find(gold, "%.") + 1, string.find(gold, "%.") + 2)
					local JackpotCopper = string.sub(gold, string.find(gold, "%.") + 3)
					local JackpotMessageString = ""
					if tonumber(JackpotCopper) == 0 then
						if tonumber(JackpotSilver) == 0 then
							if tonumber(JackpotGold) > 0 then
								JackpotMessageString = JackpotGold .. " " .. L["Value_Gold"]
							end
						else
							if tonumber(JackpotGold) == 0 then
								JackpotMessageString = JackpotSilver .. " " .. L["Value_Silver"]
							else
								JackpotMessageString = JackpotGold .. " " .. L["Value_Gold"] .. " " .. JackpotSilver .. " " .. L["Value_Silver"]
							end
						end
					else
						if tonumber(JackpotSilver) == 0 then
							if tonumber(JackpotGold) == 0 then
								JackpotMessageString = JackpotCopper .. " " .. L["Value_Copper"]
							else
								JackpotMessageString = JackpotGold .. " " .. L["Value_Gold"] .. " " .. JackpotCopper .. " " .. L["Value_Copper"]
							end
						else
							if tonumber(JackpotGold) == 0 then
								JackpotMessageString = JackpotSilver .. " " .. L["Value_Silver"] .. " " .. JackpotCopper .. " " .. L["Value_Copper"]
							else
								JackpotMessageString = JackpotGold .. " " .. L["Value_Gold"] .. " " .. JackpotSilver .. " " .. L["Value_Silver"] .. " " .. JackpotCopper .. " " .. L["Value_Copper"]
							end
						end
					end
					message = string.gsub(message, "%%raffle_gold", JackpotMessageString)
				end
			end
			if tickets ~= nil then
				message = string.gsub(message, "%%raffle_tickets", tickets)
			end
			if string.len(message) > 255 then
				message = L["Configuration Panel Message Too Long"]
			end
		end
	end
	if message == "" then
		return ""
	else
		return "|cFF" .. chatColor .. DateTime .. UserName .. message .. "|r"
	end
end

local function GetValidEntries() -- [f][g][r] Refer to "Faction" "Guild" "Rank"
	local faction, _ = UnitFactionGroup("PLAYER")
	local guild, _, _, _ = GetGuildInfo("PLAYER")
	local EventType
	if GiveawaySelectEventName[GiveawaySelectEvent] == L["Lottery"] then
		EventType = "Lottery"
	elseif GiveawaySelectEventName[GiveawaySelectEvent] == L["Raffle"] then
		EventType = "Raffle"
	end
	if PlayerInfo[GuildRoster] == nil then PlayerInfo = glrHistory end
	if CharacterInfo[EventType] == nil then CharacterInfo = glrCharacter end
	local MaxTickets = 0
	if CharacterInfo.Event[EventType] ~= nil then
		if CharacterInfo.Event[EventType].MaxTickets ~= nil then
			MaxTickets = tonumber(CharacterInfo.Event[EventType].MaxTickets)
		end
	end
	if not CharacterInfo.Data.Settings.MultiGuild then
		if GiveawayMultiGuildFaction ~= faction then
			for i = 1, #GiveawayMultiGuildFactionTable do
				if GiveawayMultiGuildFactionTable[i] == faction then
					GiveawayMultiGuildFactionKey = i
					GiveawayMultiGuildFaction = GiveawayMultiGuildFactionTable[GiveawayMultiGuildFactionKey]
					break
				end
			end
		end
		if GiveawayMultiGuildName ~= guild then
			for i = 1, #GiveawayMultiGuildNames[GiveawayMultiGuildFaction] do
				if GiveawayMultiGuildNames[GiveawayMultiGuildFaction][i] == guild then
					GiveawayMultiGuildKey = i
					GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
					break
				end
			end
		end
	end
	local CompareOnlineNumber = GiveawayLastOnlineTableKey
	if CharacterInfo.Data.Settings.MultiGuild and CompareOnlineNumber > 0 then CompareOnlineNumber = CompareOnlineNumber + 1 end
	if GiveawaySelectEventName[GiveawaySelectEvent] ~= L["Giveaway - No Event Active"] then
		GetMultiGuildTables()
		if GiveawayValueKey == 2 then
			if GiveawayMultiGuildName == "" then GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey] end
			for f, tf in pairs(GLR_EntryTable) do
				if f == GiveawayMultiGuildFaction then
					for g, tg in pairs(GLR_EntryTable[f]) do
						if g == GiveawayMultiGuildName then
							for r, tr in pairs(GLR_EntryTable[f][g]) do
								if GLR_EntryTable[f][g][r].State and GLR_EntryCheckTable[f][g][r].State and not GLR_EntryCheckTable[f][g][r].Check then
									if GiveawayLastOnlineTableKey == 0 then
										GiveAwayNumber = GiveAwayNumber + GLR_EntryTable[f][g][r].Count
										if not GLR_EntryCheckTable[f][g][r].Entered then
											for i = 1, #GLR_EntryTable[f][g][r].Names do
												local name = string.sub(GLR_EntryTable[f][g][r].Names[i], 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%[") - 1)
												table.insert(GLR_FinalEntryTable, name)
											end
											GLR_EntryCheckTable[f][g][r].Entered = true
										end
									else
										local IncreaseCount = 0
										if not GLR_EntryCheckTable[f][g][r].Entered then
											for i = 1, #GLR_EntryTable[f][g][r].Names do
												local UserTime = tonumber(string.sub(GLR_EntryTable[f][g][r].Names[i], string.find(GLR_EntryTable[f][g][r].Names[i], "%@") + 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%$") - 1))
												if UserTime ~= nil then
													local valid = GetTimeSinceLastLogin(UserTime)
													if valid then
														local name = string.sub(GLR_EntryTable[f][g][r].Names[i], 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%[") - 1)
														table.insert(GLR_FinalEntryTable, name)
														IncreaseCount = IncreaseCount + 1
													end
												else
													local DateString = string.sub(GLR_EntryTable[f][g][r].Names[i], string.find(GLR_EntryTable[f][g][r].Names[i], "%$") + 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%!") - 1)
													local valid = GetTimeSinceLastLoginString(DateString)
													if valid then
														local name = string.sub(GLR_EntryTable[f][g][r].Names[i], 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%[") - 1)
														table.insert(GLR_FinalEntryTable, name)
														IncreaseCount = IncreaseCount + 1
													end
												end
											end
											GLR_EntryCheckTable[f][g][r].Entered = true
										end
										GiveAwayNumber = GiveAwayNumber + IncreaseCount
									end
									GLR_EntryCheckTable[f][g][r].Check = true
								elseif not GLR_EntryTable[f][g][r].State and GLR_EntryCheckTable[f][g][r].State then
									local RemoveCount = 0
									for j = 1, #GLR_EntryTable[f][g][r].Names do
										local name = string.sub(GLR_EntryTable[f][g][r].Names[j], 1, string.find(GLR_EntryTable[f][g][r].Names[j], "%[") - 1)
										for i = 1, #GLR_FinalEntryTable do
											if name == GLR_FinalEntryTable[i] then
												table.remove(GLR_FinalEntryTable, i)
												RemoveCount = RemoveCount + 1
												break
											end
										end
									end
									if GiveAwayNumber >= 1 then
										GiveAwayNumber = GiveAwayNumber - RemoveCount
									end
									GLR_EntryCheckTable[f][g][r].State = false
									GLR_EntryCheckTable[f][g][r].Check = false
									GLR_EntryCheckTable[f][g][r].Entered = false
								end
							end
						end
					end
				end
			end
		else
			local continue = true
			local cross = glrCharacter.Data.Settings.CrossFactionEvents
			local multi = glrCharacter.Data.Settings.MultiGuild
			for f, tf in pairs(GLR_EntryTable) do
				if not cross and tostring(f) ~= faction then continue = false end
				if continue then
					for g, tg in pairs(GLR_EntryTable[f]) do
						continue = true
						if not multi and tostring(g) ~= guild then continue = false end
						if continue then
							for r, tr in pairs(GLR_EntryTable[f][g]) do
								if not GLR_EntryCheckTable[f][g][r].Check then
									if GiveawayLastOnlineTableKey == 0 then
										GiveAwayNumber = GiveAwayNumber + GLR_EntryTable[f][g][r].Count
										if not GLR_EntryCheckTable[f][g][r].Entered then
											for i = 1, #GLR_EntryTable[f][g][r].Names do
												local name = string.sub(GLR_EntryTable[f][g][r].Names[i], 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%[") - 1)
												table.insert(GLR_FinalEntryTable, name)
											end
											GLR_EntryCheckTable[f][g][r].Entered = true
										end
									else
										local IncreaseCount = 0
										if not GLR_EntryCheckTable[f][g][r].Entered then
											for i = 1, #GLR_EntryTable[f][g][r].Names do
												local UserTime = tonumber(string.sub(GLR_EntryTable[f][g][r].Names[i], string.find(GLR_EntryTable[f][g][r].Names[i], "%@") + 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%$") - 1))
												if UserTime ~= nil then
													local valid = GetTimeSinceLastLogin(UserTime)
													if valid then
														local name = string.sub(GLR_EntryTable[f][g][r].Names[i], 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%[") - 1)
														table.insert(GLR_FinalEntryTable, name)
														IncreaseCount = IncreaseCount + 1
													end
												else
													local DateString = string.sub(GLR_EntryTable[f][g][r].Names[i], string.find(GLR_EntryTable[f][g][r].Names[i], "%$") + 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%!") - 1)
													local valid = GetTimeSinceLastLoginString(DateString)
													if valid then
														local name = string.sub(GLR_EntryTable[f][g][r].Names[i], 1, string.find(GLR_EntryTable[f][g][r].Names[i], "%[") - 1)
														table.insert(GLR_FinalEntryTable, name)
														IncreaseCount = IncreaseCount + 1
													end
												end
											end
											GLR_EntryCheckTable[f][g][r].Entered = true
										end
										GiveAwayNumber = GiveAwayNumber + IncreaseCount
									end
									GLR_EntryTable[f][g][r].State = true
									GLR_EntryCheckTable[f][g][r].State = true
									GLR_EntryCheckTable[f][g][r].Check = true
								end
							end
						end
					end
				end
			end
		end
	end
	sort(GLR_FinalEntryTable)
	GiveAwayText = L["Giveaway - Names Available"] .. ": " .. tostring(GiveAwayNumber)
end

local function ResetGiveAwayTable()
	GiveawayValueKey = 1
	GiveawayLastOnlineTableKey = 0
	GiveAwayNumber = 0
	GiveAwayText = L["Giveaway - Names Available"] .. ": " .. tostring(GiveAwayNumber)
	if not glrCharacter.Data.Settings.CrossFactionEvents then
		local faction, _ = UnitFactionGroup("PLAYER")
		for i = 1, #GiveawayMultiGuildFactionTable do
			if GiveawayMultiGuildFactionTable[i] == faction then
				GiveawayMultiGuildFactionKey = i
				GiveawayMultiGuildFaction = GiveawayMultiGuildFactionTable[GiveawayMultiGuildFactionKey]
				GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
				break
			end
		end
	else
		GiveawayMultiGuildKey = 1
		GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
	end
	for f, tf in pairs(GLR_EntryTable) do
		for g, tg in pairs(GLR_EntryTable[f]) do
			for i = 1, #GiveawayMultiGuildRankSelectTable[f][g] do
				GiveawayMultiGuildRankSelectTable[f][g][i] = false
			end
			for r, tr in pairs(GLR_EntryTable[f][g]) do
				GLR_EntryTable[f][g][r].State = false
				GLR_EntryCheckTable[f][g][r].State = false
				GLR_EntryCheckTable[f][g][r].Check = false
				GLR_EntryCheckTable[f][g][r].Entered = false
			end
		end
	end
	GLR_FinalEntryTable = {}
end

local function CancelCurrentEvent(EventType)
	
	local state = EventType
	local dateTime = string.sub(date(), 1, string.find(date(), ":") - 4)
	local EventStatus = false
	local continue = false
	
	if state == "Lottery" then
		if GLR_ConfirmCancelLottery then
			continue = true
		end
	else
		if GLR_ConfirmCancelRaffle then
			continue = true
		end
	end
	
	if continue then
		
		glrCharacter.Data.Defaults.LotteryDate = dateTime
		
		if state == "Lottery" then
			local startingGold = tostring(glrCharacter.Data.Settings.PreviousLottery.Jackpot)
			local jackpotGold = startingGold
			
			GLR_UI.GLR_LotteryInfo.GLR_LotteryDateEditBox:SetText("")
			GLR_UI.GLR_LotteryInfo.GLR_LotteryNameEditBox:SetText(L["No Lottery Active"])
			GLR_UI.GLR_LotteryInfo.GLR_LotteryNameEditBox:SetCursorPosition(0)
			GLR_UI.GLR_LotteryInfo.GLR_StartingGoldEditBox:SetText(startingGold)
			GLR_UI.GLR_LotteryInfo.GLR_JackpotEditBox:SetText(jackpotGold)
			GLR_UI.GLR_LotteryInfo.GLR_MaxTicketsEditBox:SetText(glrCharacter.Data.Defaults.LotteryMaxTickets)
			GLR_UI.GLR_LotteryInfo.GLR_TicketPriceEditBox:SetText(glrCharacter.Data.Defaults.TicketPrice)
			GLR_UI.GLR_LotteryInfo.GLR_SecondPlaceEditBox:SetText(glrCharacter.Data.Defaults.SecondCut)
			GLR_UI.GLR_LotteryInfo.GLR_GuildAmountEditBox:SetText(glrCharacter.Data.Defaults.GuildCut)
			if glrHistory.TransferData[FullPlayerName].Data ~= nil then
				glrHistory.TransferData[FullPlayerName].Data.Settings.PreviousLottery = nil
				glrHistory.TransferData[FullPlayerName].Data.Settings.TicketSeries = nil
			end
		else
			GLR_UI.GLR_RaffleInfo.GLR_RaffleDateEditBox:SetText("")
			GLR_UI.GLR_RaffleInfo.GLR_RaffleNameEditBox:SetText(L["No Raffle Active"])
			GLR_UI.GLR_RaffleInfo.GLR_RaffleNameEditBox:SetCursorPosition(0)
			GLR_UI.GLR_RaffleInfo.GLR_RaffleMaxTicketsEditBox:SetText(glrCharacter.Data.Defaults.RaffleMaxTickets)
			GLR_UI.GLR_RaffleInfo.GLR_RaffleTicketPriceEditBox:SetText(glrCharacter.Data.Defaults.TicketPrice)
			GLR_UI.GLR_RaffleInfo.GLR_RaffleFirstPlacePrizeEditBox:SetText("")
			GLR_UI.GLR_RaffleInfo.GLR_RaffleSecondPlacePrizeEditBox:SetText("")
			GLR_UI.GLR_RaffleInfo.GLR_RaffleThirdPlacePrizeEditBox:SetText("")
			if glrHistory.TransferData[FullPlayerName].Data ~= nil then
				glrHistory.TransferData[FullPlayerName].Data.Settings.AllowMultipleRaffleWinners = nil
				glrHistory.TransferData[FullPlayerName].Data.Settings.RaffleSeries = nil
				glrHistory.TransferData[FullPlayerName].Data.Raffle = nil
			end
		end
		
		GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderLow:SetText("0")
		GLR_UI.GLR_MainFrame.GLR_TicketNumberRangeBorderHigh:SetText("0")
		
		glrCharacter.Event[state] = nil
		glrCharacter.Event[state] = {}
		
		glrCharacter[state].TicketPool = nil
		glrCharacter[state].TicketPool = {}
		
		glrCharacter[state].Entries.TicketRange = nil
		glrCharacter[state].Entries.TicketRange = {}
		
		glrCharacter[state].Entries.TicketNumbers = nil
		glrCharacter[state].Entries.TicketNumbers = {}
		
		glrCharacter[state].Entries.Tickets = nil
		glrCharacter[state].Entries.Tickets = {}
		
		glrCharacter[state].Entries.Names = nil
		glrCharacter[state].Entries.Names = {}
		
		glrCharacter[state].MessageStatus = nil
		glrCharacter[state].MessageStatus = {}
		
		glrCharacter.Data.OtherStatus[state] = nil
		glrCharacter.Data.OtherStatus[state] = {}
		
		if glrHistory.TransferData[FullPlayerName][state] ~= nil and glrHistory.TransferData[FullPlayerName].Event ~= nil then
			glrHistory.TransferData[FullPlayerName][state] = nil
			glrHistory.TransferData[FullPlayerName].Event[state] = nil
		end
		
		glrHistory.TransferAvailable[state][FullPlayerName] = false
		
		glrTemp[state] = nil
		glrTemp[state] = {}
		
		glrTempStatus = nil
		glrTempStatus = {}
		
		GLR:UpdatePlayersAndTotalTickets()
		GLR:UpdateNumberOfUnusedTickets()
		
		if glrHistory.ActiveEvents == nil then
			glrHistory.ActiveEvents = {}
		end
		
		if state == "Lottery" then
			glrCharacter.Data.Settings.CurrentlyActiveLottery = false
			glrLotteryDrawInProgress = false
			GLR_UI.GLR_MainFrame.GLR_LotteryFrame.GLR_AddPlayerToLotteryButton:Disable()
			GLR_UI.GLR_MainFrame.GLR_LotteryFrame.GLR_EditPlayerInLotteryButton:Disable()
			GLR_UI.GLR_MainFrame.GLR_LotteryFrame.GLR_DonationButton:Disable()
			GLR:Print(L["Lottery Canceled Message"])
		else
			glrCharacter.Data.Settings.CurrentlyActiveRaffle = false
			glrRaffleDrawInProgress = false
			GLR_UI.GLR_MainFrame.GLR_RaffleFrame.GLR_AddPlayerToRaffleButton:Disable()
			GLR_UI.GLR_MainFrame.GLR_RaffleFrame.GLR_EditPlayerInRaffleButton:Disable()
			GLR:Print(L["Raffle Canceled Message"])
		end
		
		if glrCharacter.Data.Settings.CurrentlyActiveRaffle or glrCharacter.Data.Settings.CurrentlyActiveLottery then --Checks if a Lottery/Raffle is currently Active before confirming that both Lottery/Raffle's are inactive, allowing you to change Multi-Guild status on your character (assuming no other events are active on other characters)
			EventStatus = true
		end
		
		if glrHistory.ActiveEvents[FullPlayerName] == nil then
			glrHistory.ActiveEvents[FullPlayerName] = EventStatus
		else
			glrHistory.ActiveEvents[FullPlayerName] = EventStatus
		end
		
		local LotteryStatus = tostring(glrCharacter.Data.Settings.CurrentlyActiveLottery)
		local RaffleStatus = tostring(glrCharacter.Data.Settings.CurrentlyActiveRaffle)
		C_ChatInfo.SendAddonMessage("GLR_CHECK", "%lottery_" .. LotteryStatus .. "!%raffle_" .. RaffleStatus, "GUILD")
		
		GLR_U:UpdateInfo(false)
		ResetGiveAwayTable()
		
	else
		GLR:Print(L["Confirm Cancel False"])
	end
	
end

function GLR_O:OptionsTable()
	
	local options = {
		name = "Guild Lottery & Raffles",
		type = "group",
		handler = GLRoptions,
		args = {
			glrInfo = {
				order = 1,
				type = "group",
				name = L["Configuration Panel Information Tab"],
				childGroups = "tab",
				args = {
					Version = {
						order = 1,
						type = "description",
						name = "|cFF87CEFAv" .. GLR_Version .. "|r",
					},
					Version_Author = {
						order = 2,
						type = "description",
						name = "|cFFFFE300" .. L["Configuration Panel Mod Author"] .. " |r" .. "|cffffffffTempuseteri-Area52|r", 
					},
					Version_Previous_Authors = {
						order = 3,
						type = "description",
						name = "|cFFFFE300" .. L["Configuration Panel Previous Authors"] .. " |r" .. "|cffffffffReaper_029, Malaron|r",
					},
					General_Translators = {
						order = 4,
						type = "description",
						name = "|cFFFFE300" .. L["Configuration Panel Translators"] .. " |r" .. "|cffffffffSkoldgaster (Spanish), QCElysiums (French).|r",
					},
					General_Toggle_Enable = {
						order = 5,
						type = "toggle",
						name = L["Configuration Panel Toggle GLR"],
						desc = L["Configuration Panel Toggle GLR Description"],
						width = "double",
						get = function()
							local status = glrCharacter.Data.Settings.enabled
							if not status then
								if GLR_UI.GLR_MainFrame:IsVisible() then
									GLR_UI.GLR_MainFrame:Hide()
								end
							end
							return glrCharacter.Data.Settings.enabled
						end,
						set = function(info, value)
							glrCharacter.Data.Settings.enabled = value
						end,
					},
					SlashCommands_Header = {
						order = 6,
						type = "header",
						name = L["Configuration Panel Slash Command List"],
					},
					SlashCommands_GLR_GUI = {
						order = 7,
						type = "description",
						name = "|cFFFFE300/glr |r" .. "|cffffffffor|r" .. "|cFFFFE300 /glr open |r" .. "|cffffffff- " .. L["Configuration Panel Open GLR Command"] .. "|r",
					},
					SlashCommands_GLR_Help = {
						order = 8,
						type = "description",
						name = "|cFFFFE300/glr help |r" .. "|cffffffff- " .. L["Configuration Panel Help Command"] .. "|r",
					},
					SlashCommands_GLR_Config = {
						order = 9,
						type = "description",
						name = "|cFFFFE300/glr config |r" .. "|cffffffff- " .. L["Configuration Panel Config Command"] .. "|r",
					},
					SlashCommands_GLR_Events = {
						order = 10,
						type = "description",
						name = "|cFFFFE300/glr events |r" .. "|cffffffff- Brings you to the Events Configuration menu.|r",
					},
					SlashCommands_GLR_Profiles = {
						order = 11,
						type = "description",
						name = "|cFFFFE300/glr profiles |r" .. "|cffffffff- Brings you to the Profiles Configuration menu.|r",
					},
					SlashCommands_GLR_Messages = {
						order = 12,
						type = "description",
						name = "|cFFFFE300/glr messages |r" .. "|cffffffff- Brings you to the Messages Configuration menu.|r",
					},
					SlashCommands_GLR_Giveaways = {
						order = 13,
						type = "description",
						name = "|cFFFFE300/glr giveaway |r" .. "|cffffffff- Brings you to the Giveaway Configuration menu.|r",
					},
					SlashCommands_GLR_Export_Lottery = {
						order = 14,
						type = "description",
						name = "|cFFFFE300/glr export " .. string.lower(L["Lottery"]) .. " |r" .. "|cffffffff- " .. "Exports previous Lottery Event data, to be imported into Excel." .. "|r",
					},
					SlashCommands_GLR_Export_Raffle = {
						order = 15,
						type = "description",
						name = "|cFFFFE300/glr export " .. string.lower(L["Raffle"]) .. " |r" .. "|cffffffff- " .. "Exports previous Raffle Event data, to be imported into Excel." .. "|r",
					},
					General_spacer1 = {
						order = 16,
						type = "description",
						name = " ",
					},
					HowTo_Header = {
						order = 17,
						type = "header",
						name = L["Configuration Panel How To Header"],
					},
					HowTo_Step_1 = {
						order = 18,
						type = "description",
						name = "|cFF87CEFA" .. L["Configuration Panel How To Step 1 P1"] .. "|r: " .. L["Configuration Panel How To Step 1 P2"],
					},
					HowTo_Step_2 = {
						order = 19,
						type = "description",
						name = "|cFF87CEFA" .. L["Configuration Panel How To Step 2 P1"] .. "|r: " .. L["Configuration Panel How To Step 2 P2"],
					},
					HowTo_Step_3 = {
						order = 20,
						type = "description",
						name = "|cFF87CEFA" .. L["Configuration Panel How To Step 3 P1"] .. "|r: " .. L["Configuration Panel How To Step 3 P2"],
					},
					HowTo_Step_4 = {
						order = 21,
						type = "description",
						name = "|cFF87CEFA" .. L["Configuration Panel How To Step 4 P1"] .. "|r: " .. L["Configuration Panel How To Step 4 P2"],
					},
				},
			},
			generalOptions = {
				order = 2,
				type = "group",
				name = L["Configuration Panel Options Tab"],
				childGroups = "tab",
				args = {
					ConfigTab = {
						order = 1,
						type = "group",
						name = L["Configuration Panel Options Tab Config"],
						childGroups = "tab",
						args = {
							Options_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Options Header"],
							},
							GeneralTab = {
								order = 2,
								type = "group",
								name = L["Configuration Panel Options Tab General"],
								childGroups = "tab",
								args = {
									General_Header = {
										order = 1,
										type = "header",
										name = L["Configuration Panel General Options Header"],
									},
									General_Open_GLR = {
										order = 2,
										type = "execute",
										name = L["Configuration Panel Options Open GLR Button"],
										desc = L["Configuration Panel Options Open GLR Button Desc"],
										width = "full",
										func = function()
											InterfaceOptionsFrame_Show()
											if GLR_UI.GLR_MainFrame:IsVisible() == false then
												GLR:ShowGLRFrame()
											end
										end,
									},
									General_Toggle_Escape = {
										order = 3,
										type = "toggle",
										name = L["Configuration Panel Options Toggle Escape Key"],
										desc = L["Configuration Panel Options Toggle Escape Key Desc"],
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.ToggleEscape
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.ToggleEscape = value
											GLR_U:ToggleEscapeKey()
										end,
									},
									General_Toggle_ChatInfo = {
										order = 4,
										type = "toggle",
										name = L["Configuration Panel Options Toggle Chat Info"],
										desc = L["Configuration Panel Options Toggle Chat Info Desc"],
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.ToggleChatInfo
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.ToggleChatInfo = value
										end,
									},
									General_Toggle_SendLargeInfo = {
										order = 5,
										type = "toggle",
										name = L["Configuration Panel Options Toggle Full Ticket Info"],
										desc = L["Configuration Panel Options Toggle Full Ticket Info Desc"],
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.SendLargeInfo
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.SendLargeInfo = value
										end,
									},
									General_Toggle_MultiGuild = {
										order = 6,
										type = "toggle",
										name = L["Configuration Panel Options Toggle Multi Guild"],
										desc = L["Configuration Panel Options Toggle Multi Guild Desc"],
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.MultiGuild
										end,
										set = function(info, value)
											local status = false
											local ActiveEventOn = ""
											local OtherToonActive = false
											if glrCharacter.Data.Settings.CurrentlyActiveLottery or glrCharacter.Data.Settings.CurrentlyActiveRaffle then
												status = true
											end
											if not status then --Checks your other characters to see if they have events running, preventing you from un/linking your guild while a event is active.
												if glrHistory.ActiveEvents ~= nil then
													for name, event in pairs(glrHistory.ActiveEvents) do
														if event then
															status = true
															OtherToonActive = true
															ActiveEventOn = tostring(name)
															break
														end
													end
												end
											end
											if not status then --Prevents changing this value while a Lottery/Raffle is active
												glrCharacter.Data.Settings.MultiGuild = value
												if glrHistory.MultiGuildStatus[FullPlayerName] ~= nil then
													glrHistory.MultiGuildStatus[FullPlayerName] = value
												end
											else
												if not OtherToonActive then
													GLR:Print(L["Configuration Panel Options Toggle Multi Guild Failed"])
												else
													local message = string.gsub(L["Configuration Panel Options Toggle Multi Guild Failed Other Toon"], "%%name", ActiveEventOn)
													GLR:Print(message)
												end
											end
											GLR_U:GetLinkedNames()
											GLR_U:GetLinkedGuilds()
											GLR_U:UpdateMultiGuildTable()
										end,
									},
									General_Toggle_CrossFactionEvents = {
										order = 7,
										type = "toggle",
										name = L["Configuration Panel Options Toggle Cross Faction"],
										desc = L["Configuration Panel Options Toggle Cross Faction Desc"],
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.CrossFactionEvents
										end,
										set = function(info, value)
											local lottery = glrCharacter.Data.Settings.CurrentlyActiveLottery
											local raffle = glrCharacter.Data.Settings.CurrentlyActiveRaffle
											if not lottery and not raffle then --Prevents changing this value while a Lottery/Raffle is active
												glrCharacter.Data.Settings.CrossFactionEvents = value
											else
												GLR:Print(L["Configuration Panel Options Toggle Cross Faction Failed"])
											end
										end,
									},
									General_Toggle_AutomatedLoginMessages = {
										order = 8,
										type = "toggle",
										name = "Disable Messages",
										desc = "Disable Login Messages\n\nIf enabled, you will no longer automatically message players upon logging in.\nRequires a Reload for settings to take effect.",
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.DisableLoginMessages
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.DisableLoginMessages = value
										end,
									},
									General_Toggle_CalendarEvents = {
										order = 9,
										type = "toggle",
										name = L["Configuration Panel Options Toggle Calendar Events"],
										desc = L["Configuration Panel Options Toggle Calendar Events Desc"],
										width = "double",
										get = function()
											return glrCharacter.Data.Settings.CreateCalendarEvents
										end,
										set = function(info, value)
											GLR_C:Toggle()
										end,
									},
									General_Toggle_CompleteRandomization = {
										order = 10,
										type = "toggle",
										hidden = true, --Feature not integrated completely. Changing or removing this value may break the AddOn for you.
										name = "Advanced Ticket Draw",
										desc = "|cffff0000Attention: This feature is not fully integrated!|r\n|cff00ffffThis feature completely changes how your Events work and can only be changed when no Event is active.",
										width = "normal",
										get = function()
											return glrCharacter.Data.Settings.AdvancedTicketDraw
										end,
										set = function(info, value)
											local lottery = glrCharacter.Data.Settings.CurrentlyActiveLottery
											local raffle = glrCharacter.Data.Settings.CurrentlyActiveRaffle
											if not lottery and not raffle then --Prevents changing this value while a Lottery/Raffle is active
												glrCharacter.Data.Settings.AdvancedTicketDraw = value
											else
												GLR:Print(L["Configuration Panel Options Toggle Randomize Tickets Failed"])
											end
										end,
									},
									General_Range_TimeBetweenAlerts = {
										order = 11,
										type = "range",
										name = L["Configuration Panel Options Time Between Alerts"],
										desc = L["Configuration Panel Options Time Between Alerts Desc"],
										width = "full",
										min = 30,
										max = 600,
										step = 1,
										get = function()
											return glrCharacter.Data.Settings.TimeBetweenAlerts
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.TimeBetweenAlerts = value
										end,
									},
								},
							},
							General_MinimapTab = {
								order = 3,
								type = "group",
								name = L["Configuration Panel Options Tab Minimap"],
								childGroups = "tab",
								args = {
									General_Minimap_Header = {
									 order = 1,
									 type = "header",
									 name = L["Configuration Panel Options Minimap Header"],
									},
									General_Toggle_Minimap = {
										order = 2,
										type = "toggle",
										name = L["Configuration Panel Options Minimap Toggle"],
										desc = L["Configuration Panel Options Minimap Toggle Desc"],
										width = "double",
										get = function()
											return glrCharacter.Data.Settings.mini_map
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.mini_map = value
											GLR_U:UpdateMinimapIcon()
										end,
									},
									General_Range_MinimapX = {
										order = 3,
										type = "range",
										name = L["Configuration Panel Options Minimap X Range"],
										desc = L["Configuration Panel Options Minimap X Range Desc"],
										width = "full",
										min = -100,
										max = 100,
										step = 0.1,
										get = function()
											local n = tonumber(string.format("%.1f", glrCharacter.Data.Settings.MinimapXOffset))
											return n
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.MinimapXOffset = value
											GLR_U:UpdateMinimapIcon()
										end,
									},
									General_Range_MinimapY = {
										order = 4,
										type = "range",
										name = L["Configuration Panel Options Minimap Y Range"],
										desc = L["Configuration Panel Options Minimap Y Range Desc"],
										width = "full",
										min = -100,
										max = 100,
										step = 0.1,
										get = function ()
											local n = tonumber(string.format("%.1f", glrCharacter.Data.Settings.MinimapYOffset))
											return n
										end,
										set = function(info, value)
											glrCharacter.Data.Settings.MinimapYOffset = value
											GLR_U:UpdateMinimapIcon()
										end,
									},
								},
							},
							MultiGuildsTab = {
								order = 6,
								type = "group",
								name = L["Configuration Panel Options Tab Multi-Guild"],
								childGroups = "tab",
								args = {
									MultiGuilds_Header = {
										order = 1,
										type = "header",
										name = L["Configuration Panel Options Guild Header"],
									},
									MultiGuilds_Description = {
										order = 2,
										type = "description",
										name = L["Configuration Panel Options Multi-Guild Description"],
										width = "full",
									},
									MultiGuilds_LinkedGuilds = {
										order = 3,
										type = "multiselect",
										name = L["Configuration Panel Options Multi-Guild Linked Guilds"],
										desc = L["Configuration Panel Options Multi-Guild Tooltip"],
										width = "full",
										values = glrTempGuilds,
										get = function(info, key)
											local guild = string.sub(glrTempGuilds[key], 1, string.find(glrTempGuilds[key], '-') - 2)
											local doBreak = false
											for i = 1, #glrHistory.Names do
												local name = glrHistory.Names[i]
												if glrHistory.CharacterGuilds[name] == guild then
													for t, v in pairs(glrHistory.CharacterGuilds) do
														if glrHistory.CharacterGuilds[name] == v then
															local faction = glrHistory.PlayerFaction[name]
															local status = glrHistory.MultiGuildStatus[name]
															glrHistory.GuildStatus[faction][v] = status
															local GuildName = glrHistory.GuildStatus[faction][v]
															if status then
																doBreak = true
																return glrHistory.GuildStatus[faction][v]
															end
														end
													end
												end
												if doBreak then
													break
												end
											end
										end,
										set = function(info, key, value)
											local guild = string.sub(glrTempGuilds[key], 1, string.find(glrTempGuilds[key], '-') - 2)
											local status = false
											local ActiveEventOn = ""
											local OtherToonActive = false
											if glrCharacter.Data.Settings.CurrentlyActiveLottery or glrCharacter.Data.Settings.CurrentlyActiveRaffle then
												status = true
											end
											if not status then --Checks your other characters to see if they have events running, preventing you from un/linking your guild while a event is active.
												if glrHistory.ActiveEvents ~= nil then
													for t, v in pairs(glrHistory.ActiveEvents) do
														if v then
															status = true
															OtherToonActive = true
															ActiveEventOn = tostring(t)
															break
														end
													end
												end
											end
											if not status then --Prevents changing this value while a Lottery/Raffle is active
												for i = 1, #glrHistory.Names do
													local name = glrHistory.Names[i]
													if glrHistory.CharacterGuilds[name] == guild then
														for t, v in pairs(glrHistory.CharacterGuilds) do
															if glrHistory.CharacterGuilds[name] == v then
																local faction = glrHistory.PlayerFaction[name]
																glrHistory.MultiGuildStatus[name] = value
																glrHistory.GuildStatus[faction][v] = value
															end
														end
														if name == FullPlayerName then
															glrCharacter.Data.Settings.MultiGuild = value
														end
													end
												end
											else
												if not OtherToonActive then
													GLR:Print(L["Configuration Panel Options Toggle Multi Guild Failed"])
												else
													local message = string.gsub(L["Configuration Panel Options Toggle Multi Guild Failed Other Toon"], "%%name", ActiveEventOn)
													GLR:Print(message)
												end
											end
											GLR_U:GetLinkedNames()
											GLR_U:GetLinkedGuilds()
										end,
									},
									MultiGuilds_PlayerNames = {
										order = 4,
										type = "multiselect",
										name = L["Configuration Panel Options Multi-Guild Linked Characters"],
										desc = L["Configuration Panel Options Multi-Guild Tooltip"],
										width = "full",
										values = glrTempNames,
										get = function(info, key)
											local name = glrTempNames[key]
											return glrHistory.MultiGuildStatus[name]
										end,
										set = function(info, key, value)
											local name = glrTempNames[key]
											local status = false
											local ActiveEventOn = ""
											local OtherToonActive = false
											if glrCharacter.Data.Settings.CurrentlyActiveLottery or glrCharacter.Data.Settings.CurrentlyActiveRaffle then
												status = true
											end
											if not status then --Checks your other characters to see if they have events running, preventing you from un/linking your guild while a event is active.
												if glrHistory.ActiveEvents ~= nil then
													for t, v in pairs(glrHistory.ActiveEvents) do
														if v then
															status = true
															OtherToonActive = true
															ActiveEventOn = tostring(t)
															break
														end
													end
												end
											end
											if not status then --Prevents changing this value while a Lottery/Raffle is active
												if name ~= nil then
													glrHistory.MultiGuildStatus[name] = value
													if name == FullPlayerName then
														glrCharacter.Data.Settings.MultiGuild = value
													end
												end
											else
												if not OtherToonActive then
													GLR:Print(L["Configuration Panel Options Toggle Multi Guild Failed"])
												else
													local message = string.gsub(L["Configuration Panel Options Toggle Multi Guild Failed Other Toon"], "%%name", ActiveEventOn)
													GLR:Print(message)
												end
											end
											GLR_U:GetLinkedNames()
											GLR_U:GetLinkedGuilds()
										end,
									},
								},
							},
							TransferDataTab = {
								order = 7,
								type = "group",
								name = L["Configuration Panel Options Tab Transfer"],
								childGroups = "tree",
								args = {
									TransferData_Header = {
										order = 1,
										type = "header",
										name = L["Configuration Panel Options Transfer Header"],
									},
									TransferData_Lottery = {
										order = 2,
										type = "group",
										name = L["Lottery"],
										childGroups = "tree",
										args = {
											TransferData_Select_Lottery_Names = {
												order = 1,
												type = "select",
												name = function(info) return string.gsub(L["Configuration Panel Options Transfer Select Name"], "%%event", L["Lottery"]) end,
												desc = function(info) return string.gsub(L["Configuration Panel Options Transfer Select Name Desc"], "%%event", L["Lottery"]) end,
												style = "dropdown",
												width = "normal",
												values = function()
													local status = glrCharacter.Data.Settings.MultiGuild
													local continue = false
													local t = {}
													local c = 0
													LotteryTransferTable = {}
													if glrHistory.TransferAvailable.Lottery ~= nil then
														if glrHistory.TransferAvailable.Lottery[FullPlayerName] ~= nil then
															for id, val in pairs(glrHistory.TransferAvailable.Lottery) do
																if id ~= FullPlayerName then
																	if glrHistory.MultiGuildStatus[id] == status then
																		if glrHistory.TransferAvailable.Lottery[id] then
																			if glrHistory.CharacterGuilds[FullPlayerName] == glrHistory.CharacterGuilds[id] or status then
																				if glrHistory.PlayerFaction[FullPlayerName] == glrHistory.PlayerFaction[id] or glrHistory.CrossFaction[FullPlayerName] == glrHistory.CrossFaction[id] then
																					continue = true
																				end
																				if continue then
																					table.insert(t, id)
																					c = c + 1
																					LotteryTransferTable[c] = id
																				end
																			end
																		end
																	end
																end
															end
														end
													end
													if c == 0 then
														table.insert(t, L["GLR_Error_No_Entries_Found"])
														return t
													else
														sort(LotteryTransferTable)
														sort(t)
														return t
													end
												end,
												get = function()
													return GLR_SelectLotteryTransferPlayer
												end,
												set = function(_, key)
													GLR_SelectLotteryTransferPlayer = key
												end,
											},
											TransferData_Toggle_ConfirmLottery = {
												order = 2,
												type = "toggle",
												name = L["Confirm Action"],
												hidden = function(self) if LotteryTransferTable[1] ~= nil then if LotteryTransferTable[1] == L["GLR_Error_No_Entries_Found"] then return true else return false end else return true end end,
												get = function()
													return ConfirmTransferLotteryData
												end,
												set = function(info, val)
													ConfirmTransferLotteryData = val
												end,
											},
											TransferData_Execute_Lottery = {
												order = 3,
												type = "execute",
												name = L["Configuration Panel Options Transfer Data"],
												desc = function(info) return string.gsub(L["Configuration Panel Options Transfer Data Desc"], "%%event", L["Lottery"]) end,
												hidden = function(self) if ConfirmTransferLotteryData then return false else return true end end,
												width = "normal",
												func = function()
													if ConfirmTransferLotteryData and GLR_SelectLotteryTransferPlayer ~= 0 then
														local name = LotteryTransferTable[GLR_SelectLotteryTransferPlayer]
														if name ~= L["GLR_Error_No_Entries_Found"] then
															if not glrHistory.TransferStatus.Lottery[name] then
																glrHistory.TransferStatus.Lottery[name] = true
																glrHistory.TransferAvailable.Lottery[name] = false
																glrCharacter.Event.Lottery = glrHistory.TransferData[name].Event.Lottery
																glrCharacter.Lottery = glrHistory.TransferData[name].Lottery
																glrCharacter.Data.Settings.PreviousLottery = glrHistory.TransferData[name].Data.Settings.PreviousLottery
																glrCharacter.Data.Settings.TicketSeries = glrHistory.TransferData[name].Data.Settings.TicketSeries
																glrCharacter.Data.OtherStatus.Lottery = glrHistory.TransferData[name].Data.OtherStatus.Lottery
																glrCharacter.Data.Settings.NoGuildCut = glrHistory.TransferData[name].Data.Settings.NoGuildCut
																glrCharacter.Data.Settings.CurrentlyActiveLottery = true
																glrHistory.TransferData[name].Data.Settings.NoGuildCut = nil
																glrHistory.TransferData[name].Data.OtherStatus.Lottery = nil
																glrHistory.TransferData[name].Data.Settings.PreviousLottery = nil
																glrHistory.TransferData[name].Data.Settings.TicketSeries = nil
																glrHistory.TransferData[name].Lottery = nil
																glrHistory.TransferData[name].Event.Lottery = nil
																ConfirmTransferLotteryData = false
																GLR_U:UpdateInfo()
																if not glrHistory.TransferAvailable.Lottery[name] and not glrHistory.TransferAvailable.Raffle[name] then
																	glrHistory.ActiveEvents[name] = false
																end
																local message = string.gsub(L["Configuration Panel Options Transfer Completed"], "%%name", name)
																GLR:Print(message)
															end
														end
													end
												end,
											},
										},
									},
									TransferData_Raffle = {
										order = 3,
										type = "group",
										name = L["Raffle"],
										childGroups = "tree",
										args = {
											TransferData_Select_Raffle_Names = {
												order = 1,
												type = "select",
												name = function(info) return string.gsub(L["Configuration Panel Options Transfer Select Name"], "%%event", L["Raffle"]) end,
												desc = function(info) return string.gsub(L["Configuration Panel Options Transfer Select Name Desc"], "%%event", L["Raffle"]) end,
												style = "dropdown",
												width = "normal",
												values = function()
													local status = glrCharacter.Data.Settings.MultiGuild
													local continue = false
													local t = {}
													local c = 0
													RaffleTransferTable = {}
													if glrHistory.TransferAvailable.Raffle ~= nil then
														if glrHistory.TransferAvailable.Raffle[FullPlayerName] ~= nil then
															for id, val in pairs(glrHistory.TransferAvailable.Raffle) do
																if id ~= FullPlayerName then
																	if glrHistory.MultiGuildStatus[id] == status then
																		if glrHistory.TransferAvailable.Raffle[id] then
																			if glrHistory.CharacterGuilds[FullPlayerName] == glrHistory.CharacterGuilds[id] or status then
																				if glrHistory.PlayerFaction[FullPlayerName] == glrHistory.PlayerFaction[id] or glrHistory.CrossFaction[FullPlayerName] == glrHistory.CrossFaction[id] then
																					continue = true
																				end
																				if continue then
																					table.insert(t, id)
																					c = c + 1
																					RaffleTransferTable[c] = id
																				end
																			end
																		end
																	end
																end
															end
														end
													end
													if c == 0 then
														table.insert(t, L["GLR_Error_No_Entries_Found"])
														return t
													else
														sort(RaffleTransferTable)
														sort(t)
														return t
													end
												end,
												get = function()
													return GLR_SelectRaffleTransferPlayer
												end,
												set = function(_, key)
													GLR_SelectRaffleTransferPlayer = key
												end,
											},
											TransferData_Toggle_ConfirmRaffle = {
												order = 2,
												type = "toggle",
												name = L["Confirm Action"],
												width = "normal",
												hidden = function(self) if RaffleTransferTable[1] ~= nil then if RaffleTransferTable[1] == L["GLR_Error_No_Entries_Found"] then return true else return false end else return true end end,
												get = function()
													return ConfirmTransferRaffleData
												end,
												set = function(info, val)
													ConfirmTransferRaffleData = val
												end,
											},
											TransferData_Execute_Raffle = {
												order = 3,
												type = "execute",
												name = L["Configuration Panel Options Transfer Data"],
												desc = function(info) return string.gsub(L["Configuration Panel Options Transfer Data Desc"], "%%event", L["Raffle"]) end,
												width = "normal",
												hidden = function(self) if ConfirmTransferRaffleData then return false else return true end end,
												func = function()
													if ConfirmTransferRaffleData and GLR_SelectRaffleTransferPlayer ~= 0 then
														local name = RaffleTransferTable[GLR_SelectRaffleTransferPlayer]
														if name ~= L["GLR_Error_No_Entries_Found"] then
															if not glrHistory.TransferStatus.Raffle[name] then
																glrHistory.TransferStatus.Raffle[name] = true
																glrHistory.TransferAvailable.Raffle[name] = false
																glrCharacter.Event.Raffle = glrHistory.TransferData[name].Event.Raffle
																glrCharacter.Raffle = glrHistory.TransferData[name].Raffle
																glrCharacter.Data.Raffle = glrHistory.TransferData[name].Data.Raffle
																glrCharacter.Data.Settings.RaffleSeries = glrHistory.TransferData[name].Data.Settings.RaffleSeries
																glrCharacter.Data.Settings.AllowMultipleRaffleWinners = glrHistory.TransferData[name].Data.Settings.AllowMultipleRaffleWinners
																glrCharacter.Data.OtherStatus.Raffle = glrHistory.TransferData[name].Data.OtherStatus.Raffle
																glrCharacter.Data.Settings.CurrentlyActiveRaffle = true
																glrHistory.TransferData[name].Data.OtherStatus.Raffle = nil
																glrHistory.TransferData[name].Data.Settings.AllowMultipleRaffleWinners = nil
																glrHistory.TransferData[name].Data.Settings.RaffleSeries = nil
																glrHistory.TransferData[name].Data.Raffle = nil
																glrHistory.TransferData[name].Raffle = nil
																glrHistory.TransferData[name].Event.Raffle = nil
																ConfirmTransferRaffleData = false
																GLR_U:UpdateInfo()
																if not glrHistory.TransferAvailable.Lottery[name] and not glrHistory.TransferAvailable.Raffle[name] then
																	glrHistory.ActiveEvents[name] = false
																end
																local message = string.gsub(L["Configuration Panel Options Transfer Completed"], "%%name", name)
																GLR:Print(message)
															end
														end
													end
												end,
											},
										},
									},
								},
							},
						},
					},
					TicketInfoTab = {
						order = 2,
						type = "group",
						name = L["Configuration Panel Options Tab Ticket Info"],
						childGroups = "tab",
						args = {
							TicketInfo_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Ticket Info Header"],
							},
							TicketInfo_Select_LotteryPlayer = {
								order = 2,
								type = "select",
								name = L["Configuration Panel Ticket Info Select Lottery Player"],
								desc = L["Configuration Panel Ticket Info Select Lottery Player Desc"],
								style = "dropdown",
								width = "normal",
								values = function()
									local t = {}
									local c = 0
									if glrCharacter ~= nil then
										if glrCharacter.Lottery ~= nil then
											if glrCharacter.Lottery.Entries ~= nil then
												if glrCharacter.Lottery.Entries.Names ~= nil then
													for id, val in pairs(glrCharacter.Lottery.Entries.Names) do
														table.insert(t, val)
														c = c + 1
													end
												end
											end
										end
									end
									if c == 0 then
										table.insert(t, L["GLR_Error_No_Entries_Found"])
										return t
									else
										sort(t)
										return t
									end
								end,
								get = function()
									return GLR_SelectLotteryPlayer
								end,
								set = function(_, key)
									GLR_SelectLotteryPlayer = key
								end,
							},
							TicketInfo_View_LotteryPlayer = {
								order = 3,
								type = "execute",
								name = L["Configuration Panel Ticket Info Lottery Button"],
								desc = L["Configuration Panel Ticket Info Lottery Button Desc"],
								width = "normal",
								func = function()
									if not glrCharacter.Data.Settings.AdvancedTicketDraw then
										GLR:ViewPlayerTickets("Lottery")
									end
								end,
							},
							TicketInfo_Spacer = {
								order = 4,
								type = "description",
								name = "",
							},
							TicketInfo_Select_RafflePlayer = {
								order = 5,
								type = "select",
								name = L["Configuration Panel Ticket Info Select Raffle Player"],
								desc = L["Configuration Panel Ticket Info Select Raffle Player Desc"],
								style = "dropdown",
								width = "normal",
								values = function()
									local t = {}
									local c = 0
									if glrCharacter ~= nil then
										if glrCharacter.Raffle ~= nil then
											if glrCharacter.Raffle.Entries ~= nil then
												if glrCharacter.Raffle.Entries.Names ~= nil then
													for id, val in pairs(glrCharacter.Raffle.Entries.Names) do
														table.insert(t, val)
														c = c + 1
													end
												end
											end
										end
									end
									if c == 0 then
										table.insert(t, L["GLR_Error_No_Entries_Found"])
										return t
									else
										sort(t)
										return t
									end
								end,
								get = function()
									return GLR_SelectRafflePlayer
								end,
								set = function(_, key)
									GLR_SelectRafflePlayer = key
								end,
							},
							TicketInfo_View_RafflePlayer = {
								order = 6,
								type = "execute",
								name = L["Configuration Panel Ticket Info Raffle Button"],
								desc = L["Configuration Panel Ticket Info Raffle Button Desc"],
								width = "normal",
								func = function()
									if not glrCharacter.Data.Settings.AdvancedTicketDraw then
										GLR:ViewPlayerTickets("Raffle")
									end
								end,
							},
						},
					},
				},
			},
			eventSettings = {
				order = 3,
				type = "group",
				name = L["Configuration Panel Events Tab"],
				childGroups = "tree",
				args = {
					lotterySettings = {
						order = 1,
						type = "group",
						name = L["Configuration Panel Options Lottery Header"],
						childGroups = "tab",
						args = {
							Lottery_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Options Lottery Header"],
							},
							Lottery_Spacer_0 = {
								order = 2,
								type = "description",
								name = "",
								width = "full",
							},
							Lottery_Button_Cancel = {
								order = 3,
								type = "execute",
								name = L["Configuration Panel Options Cancel Lottery"],
								desc = L["Configuration Panel Options Cancel Lottery Desc"],
								width = "normal",
								func = function()
									if glrCharacter.Data.Settings.CurrentlyActiveLottery then
										CancelCurrentEvent("Lottery")
										GLR_ConfirmCancelLottery = false
									end
								end,
							},
							Lottery_Toggle_ConfirmCancel = {
								order = 4,
								type = "toggle",
								name = L["Confirm Cancel"],
								desc = L["Confirm Cancel Desc"],
								width = "normal",
								get = function()
									local status = glrCharacter.Data.Settings.CurrentlyActiveLottery
									if not status then
										return false
									end
									return GLR_ConfirmCancelLottery
								end,
								set = function(info, value)
									if glrCharacter.Data.Settings.CurrentlyActiveLottery then
										GLR_ConfirmCancelLottery = value
									end
								end,
							},
							Lottery_Event_Spacer_1 = {
								order = 5,
								type = "description",
								name = "",
								width = "full",
							},
							Lottery_Toggle_NoGuildCut = {
								order = 6,
								type = "toggle",
								name = L["Configuration Panel No Guild Cut on No Winner"],
								desc = L["Configuration Panel No Guild Cut on No Winner Desc"],
								width = "double",
								get = function()
									return glrCharacter.Data.Settings.NoGuildCut
								end,
								set = function(info, val)
									if not glrCharacter.Data.Settings.CurrentlyActiveLottery then
										glrCharacter.Data.Settings.NoGuildCut = val
									end
								end,
							},
							Lottery_Toggle_RoundJackpot = {
								order = 7,
								type = "toggle",
								name = "Round Jackpot",
								desc = "Rounds the Jackpot to the nearest Gold value.\n\nThis affects Jackpot Winners and the amount given to the Guild.",
								width = "normal",
								get = function()
									return glrCharacter.Data.Settings.RoundJackpot
								end,
								set = function(info, val)
									if not glrCharacter.Data.Settings.CurrentlyActiveLottery then
										glrCharacter.Data.Settings.RoundJackpot = val
									end
								end,
							},
							Lottery_Event_Spacer_2 = {
								order = 8,
								type = "description",
								name = "",
								width = "full",
							},
							Lottery_Execute_Export = {
								order = 9,
								type = "execute",
								name = L["Data Export - Button"],
								desc = function(info) return string.gsub(L["Data Export - Button Tooltip"], "%%e", L["Lottery"]) end,
								hidden = function(self) if glrCharacter.PreviousEvent.Lottery.Available then return false else return true end end,
								func = function()
									GLR:ExportData("Lottery")
								end,
							},
						},
					},
					raffleSettings = {
						order = 2,
						type = "group",
						name = L["Configuration Panel Options Raffle Header"],
						childGroups = "tab",
						args = {
							Raffle_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Options Raffle Header"],
							},
							Raffle_Button_Cancel = {
								order = 2,
								type = "execute",
								name = L["Configuration Panel Options Cancel Raffle"],
								desc = L["Configuration Panel Options Cancel Raffle Desc"],
								width = "normal",
								func = function()
									if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
										CancelCurrentEvent("Raffle")
										GLR_ConfirmCancelRaffle = false
									end
								end,
							},
							Raffle_Toggle_ConfirmCancel = {
								order = 3,
								type = "toggle",
								name = L["Confirm Cancel"],
								desc = L["Confirm Cancel Desc"],
								width = "normal",
								get = function()
									local status = glrCharacter.Data.Settings.CurrentlyActiveRaffle
									if not status then
										return false
									end
									return GLR_ConfirmCancelRaffle
								end,
								set = function(info, value)
									if glrCharacter.Data.Settings.CurrentlyActiveRaffle then
										GLR_ConfirmCancelRaffle = value
									end
								end,
							},
							Raffle_Spacer_1 = {
								order = 4,
								type = "description",
								name = "",
								width = "full",
							},
							Raffle_Toggle_MultipleWinners = {
								order = 5,
								type = "toggle",
								name = L["Configuration Panel Options Allow Multiple Raffle Winners"],
								desc = L["Configuration Panel Options Allow Multiple Raffle Winners Desc"],
								width = "double",
								get = function()
									return glrCharacter.Data.Settings.AllowMultipleRaffleWinners
								end,
								set = function(info, value)
									glrCharacter.Data.Settings.AllowMultipleRaffleWinners = value
								end,
							},
							Raffle_Toggle_InverseAnnouncement = {
								order = 6,
								type = "toggle",
								name = L["Raffle - Inverse Announce Order"],
								desc = L["Raffle - Inverse Announce Order Tooltip"],
								width = "double",
								get = function()
									return glrCharacter.Data.Settings.InverseAnnounce
								end,
								set = function(info, val)
									glrCharacter.Data.Settings.InverseAnnounce = val
								end
							},
							Raffle_Spacer_2 = {
								order = 7,
								type = "description",
								name = "",
								width = "full",
							},
							Raffle_Execute_Export = {
								order = 8,
								type = "execute",
								name = L["Data Export - Button"],
								desc = function(info) return string.gsub(L["Data Export - Button Tooltip"], "%%e", L["Raffle"]) end,
								hidden = function(self) if glrCharacter.PreviousEvent.Raffle.Available then return false else return true end end,
								func = function()
									GLR:ExportData("Raffle")
								end,
							},
						},
					},
				},
			},
			profileOptions = {
				order = 4,
				type = "group",
				name = L["Configuration Panel Profiles Tab"],
				childGroups = "tab",
				args = {
					general_ProfileHeader = {
						order = 1,
						type = "header",
						name = L["Configuration Panel Options Profile Header"],
					},
					general_Raffle_ProfileDescription = {
						order = 2,
						type = "description",
						name = L["Configuration Panel Options Profile Desc"],
						width = "full",
					},
					LotteryProfileTab = {
						order = 3,
						type = "group",
						name = L["Lottery"],
						childGroups = "tab",
						args = {
							SelectLotteryProfile = {
								order = 1,
								type = "select",
								name = L["Configuration Panel Options Profile Copy"],
								desc = L["Configuration Panel Options Profile Copy Lottery Desc"],
								style = "dropdown",
								width = "normal",
								values = function()
									local c = 0
									CopyLotteryProfileTable = {}
									if glrHistory ~= nil then
										if glrHistory.Profile ~= nil then
											if glrHistory.Profile.Lottery ~= nil then
												for id, val in pairs(glrHistory.Profile.Lottery) do
													if id ~= FullPlayerName then
														table.insert(CopyLotteryProfileTable, id)
														c = c + 1
													end
												end
											end
										end
									end
									if c >= 1 then
										sort(CopyLotteryProfileTable)
										return CopyLotteryProfileTable
									else
										table.insert(CopyLotteryProfileTable, L["GLR_Error_No_Entries_Found"])
										return CopyLotteryProfileTable
									end
								end,
								get = function()
									return CopyLotteryProfileName
								end,
								set = function(_, key)
									CopyLotteryProfileName = key
									local name = CopyLotteryProfileTable[key]
									for t, v in pairs(glrHistory.Profile.Lottery[name]) do
										glrHistory.Profile.Lottery[FullPlayerName][t] = glrHistory.Profile.Lottery[name][t]
									end
								end,
							},
							Spacer_1 = {
								order = 2,
								type = "description",
								name = "",
								width = "full",
							},
							StartingAmount = {
								order = 3,
								type = "input",
								name = L["Configuration Panel Options Lottery Profile Starting Gold"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Lottery.StartingGold
								end,
								set = function(info, value)
									local text = tonumber(value)
									if text == nil then
										text = "0"
									else
										if text >= 0 then
											text = tostring(text)
										else
											text = "0"
										end
									end
									glrCharacter.Data.Settings.Profile.Lottery.StartingGold = text
								end,
							},
							Spacer_2 = {
								order = 4,
								type = "description",
								name = "",
								width = "normal",
							},
							MaxTickets = {
								order = 5,
								type = "input",
								name = L["Configuration Panel Options Profile Max Tickets"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Lottery.MaxTickets
								end,
								set = function(info, value)
									local text = tonumber(value)
									if text == nil then
										text = "0"
									else
										if text >= 0 and text <= 50000 then
											text = tostring(text)
										else
											if text > 50000 then
												text = "50000"
											else
												text = "0"
											end
										end
									end
									glrCharacter.Data.Settings.Profile.Lottery.MaxTickets = text
								end,
							},
							Spacer_3 = {
								order = 6,
								type = "description",
								name = "",
								width = "full",
							},
							TicketPrice = {
								order = 7,
								type = "input",
								name = L["Configuration Panel Options Profile Ticket Price"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Lottery.TicketPrice
								end,
								set = function(info, value)
									local text = tonumber(value)
									if text == nil then
										text = "0"
									else
										if text >= 0 then
											text = tostring(text)
										else
											text = "0"
										end
									end
									glrCharacter.Data.Settings.Profile.Lottery.TicketPrice = text
								end,
							},
							Spacer_4 = {
								order = 8,
								type = "description",
								name = "",
								width = "normal",
							},
							SecondPlace = {
								order = 9,
								type = "input",
								name = L["Configuration Panel Options Lottery Profile Second Place"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Lottery.SecondPlace
								end,
								set = function(info, value)
									local text = tonumber(value)
									local compare = tonumber(glrCharacter.Data.Settings.Profile.Lottery.GuildCut)
									if text == nil then
										text = "0"
									else
										compare = text + compare
										if text >= 0 and text <= 100 and compare <= 100 then
											text = tostring(text)
										else
											text = "0"
										end
									end
									glrCharacter.Data.Settings.Profile.Lottery.SecondPlace = text
								end,
							},
							Spacer_5 = {
								order = 10,
								type = "description",
								name = "",
								width = "full",
							},
							GuildCut = {
								order = 11,
								type = "input",
								name = L["Configuration Panel Options Lottery Profile Guild Cut"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Lottery.GuildCut
								end,
								set = function(info, value)
									local text = tonumber(value)
									local compare = tonumber(glrCharacter.Data.Settings.Profile.Lottery.SecondPlace)
									if text == nil then
										text = "0"
									else
										compare = text + compare
										if text >= 0 and text <= 100 and compare <= 100 then
											text = tostring(text)
										else
											text = "0"
										end
									end
									glrCharacter.Data.Settings.Profile.Lottery.GuildCut = text
								end,
							},
							Spacer_6 = {
								order = 12,
								type = "description",
								name = "",
								width = "normal",
							},
							GuaranteeWinner = {
								order = 13,
								type = "toggle",
								name = L["Configuration Panel Options Lottery Profile Guarantee Winner"],
								desc = L["Configuration Panel Options Lottery Profile Toggle Desc"],
								width = "normal",
								get = function()
									return glrCharacter.Data.Settings.Profile.Lottery.Guaranteed
								end,
								set = function(info, value)
									glrCharacter.Data.Settings.Profile.Lottery.Guaranteed = value
								end
							},
						},
					},
					RaffleProfileTab = {
						order = 4,
						type = "group",
						name = L["Raffle"],
						childGroups = "tab",
						args = {
							SelectRaffleProfile = {
								order = 1,
								type = "select",
								name = L["Configuration Panel Options Profile Copy"],
								desc = L["Configuration Panel Options Profile Copy Raffle Desc"],
								style = "dropdown",
								width = "normal",
								values = function()
									local c = 0
									CopyRaffleProfileTable = {}
									if glrHistory ~= nil then
										if glrHistory.Profile ~= nil then
											if glrHistory.Profile.Raffle ~= nil then
												for id, val in pairs(glrHistory.Profile.Raffle) do
													if id ~= FullPlayerName then
														table.insert(CopyRaffleProfileTable, id)
														c = c + 1
													end
												end
											end
										end
									end
									if c >= 1 then
										sort(CopyRaffleProfileTable)
										return CopyRaffleProfileTable
									else
										table.insert(CopyRaffleProfileTable, L["GLR_Error_No_Entries_Found"])
										return CopyRaffleProfileTable
									end
								end,
								get = function()
									return CopyRaffleProfileName
								end,
								set = function(_, key)
									CopyRaffleProfileName = key
									local name = CopyRaffleProfileTable[key]
									for t, v in pairs(glrHistory.Profile.Raffle[name]) do
										glrHistory.Profile.Raffle[FullPlayerName][t] = glrHistory.Profile.Raffle[name][t]
									end
								end,
							},
							Spacer_1 = {
								order = 2,
								type = "description",
								name = "",
								width = "full",
							},
							MaxTickets = {
								order = 3,
								type = "input",
								name = L["Configuration Panel Options Profile Max Tickets"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Raffle.MaxTickets
								end,
								set = function(info, value)
									local text = tonumber(value)
									if text == nil then
										text = "0"
									else
										if text >= 0 and text <= 50000 then
											text = tostring(text)
										else
											if text > 50000 then
												text = "50000"
											else
												text = "0"
											end
										end
									end
									glrCharacter.Data.Settings.Profile.Raffle.MaxTickets = text
								end,
							},
							Spacer_2 = {
								order = 4,
								type = "description",
								name = "",
								width = "normal",
							},
							TicketPrice = {
								order = 5,
								type = "input",
								name = L["Configuration Panel Options Profile Ticket Price"],
								desc = L["Configuration Panel Options Profile Enter Amount Desc"],
								width = "0.75",
								get = function()
									return glrCharacter.Data.Settings.Profile.Raffle.TicketPrice
								end,
								set = function(info, value)
									local text = tonumber(value)
									if text == nil then
										text = "0"
									else
										text = tostring(text)
									end
									glrCharacter.Data.Settings.Profile.Raffle.TicketPrice = text
								end,
							},
							Spacer_3 = {
								order = 6,
								type = "description",
								name = "",
								width = "full",
							},
							InvalidItems = {
								order = 7,
								type = "toggle",
								name = L["Configuration Panel Options Raffle Profile Invalid Items"],
								desc = L["Configuration Panel Options Raffle Profile Toggle Desc"],
								width = "normal",
								get = function()
									return glrCharacter.Data.Settings.Profile.Raffle.InvalidItems
								end,
								set = function(value)
									glrCharacter.Data.Settings.Profile.Raffle.InvalidItems = value
								end,
							},
						},
					},
					MessageProfileTab = {
						order = 5,
						type = "group",
						name = L["Configuration Panel Message Tab"],
						childGroups = "tree",
						args = {
							LotteryMessageProfileTab = {
								order = 1,
								type = "group",
								name = L["Lottery"],
								childGroups = "tab",
								args = {
									SelectLotteryMessageProfile = {
										order = 1,
										type = "select",
										name = L["Configuration Panel Options Profile Copy"],
										desc = L["Configuration Panel Message Profile Copy Lottery Desc"],
										style = "dropdown",
										width = "normal",
										values = function()
											local c = 0
											CopyLotteryMessageProfileTable = {}
											if glrHistory ~= nil then
												if glrHistory.Profile ~= nil then
													if glrHistory.Profile.Messages ~= nil then
														if glrHistory.Profile.Messages.Lottery ~= nil then
															for id, val in pairs(glrHistory.Profile.Messages.Lottery) do
																if id ~= FullPlayerName then
																	table.insert(CopyLotteryMessageProfileTable, id)
																	c = c + 1
																end
															end
														end
													end
												end
											end
											if c >= 1 then
												sort(CopyLotteryMessageProfileTable)
												return CopyLotteryMessageProfileTable
											else
												table.insert(CopyLotteryMessageProfileTable, L["GLR_Error_No_Entries_Found"])
												return CopyLotteryMessageProfileTable
											end
										end,
										get = function()
											return CopyLotteryMessageProfileName
										end,
										set = function(_, key)
											CopyLotteryMessageProfileName = key
											local name = CopyLotteryMessageProfileTable[key]
											for i = 1, #glrHistory.Profile.Messages.Lottery[name] - 1 do
												glrHistory.Profile.Messages.Lottery[FullPlayerName][i] = glrHistory.Profile.Messages.Lottery[name][i]
												glrCharacter.Data.Messages.GuildAlerts.Lottery[i] = glrHistory.Profile.Messages.Lottery[name][i]
											end
										end,
									},
								},
							},
							RaffleMessageProfileTab = {
								order = 2,
								type = "group",
								name = L["Raffle"],
								childGroups = "tab",
								args = {
									SelectRaffleMessageProfile = {
										order = 1,
										type = "select",
										name = L["Configuration Panel Options Profile Copy"],
										desc = L["Configuration Panel Message Profile Copy Raffle Desc"],
										style = "dropdown",
										width = "normal",
										values = function()
											local c = 0
											CopyRaffleMessageProfileTable = {}
											if glrHistory ~= nil then
												if glrHistory.Profile ~= nil then
													if glrHistory.Profile.Messages ~= nil then
														if glrHistory.Profile.Messages.Raffle ~= nil then
															for id, val in pairs(glrHistory.Profile.Messages.Raffle) do
																if id ~= FullPlayerName then
																	table.insert(CopyRaffleMessageProfileTable, id)
																	c = c + 1
																end
															end
														end
													end
												end
											end
											if c >= 1 then
												sort(CopyRaffleMessageProfileTable)
												return CopyRaffleMessageProfileTable
											else
												table.insert(CopyRaffleMessageProfileTable, L["GLR_Error_No_Entries_Found"])
												return CopyRaffleMessageProfileTable
											end
										end,
										get = function()
											return CopyRaffleMessageProfileName
										end,
										set = function(_, key)
											CopyRaffleMessageProfileName = key
											local name = CopyRaffleMessageProfileTable[key]
											for i = 1, #glrHistory.Profile.Messages.Raffle[name] - 1 do
												glrHistory.Profile.Messages.Raffle[FullPlayerName][i] = glrHistory.Profile.Messages.Raffle[name][i]
												glrCharacter.Data.Messages.GuildAlerts.Raffle[i] = glrHistory.Profile.Messages.Raffle[name][i]
											end
										end,
									},
								},
							},
							BothMessageProfileTab = {
								order = 3,
								type = "group",
								name = L["Both"],
								childGroups = "tab",
								args = {
									SelectRaffleMessageProfile = {
										order = 1,
										type = "select",
										name = L["Configuration Panel Options Profile Copy"],
										desc = L["Configuration Panel Message Profile Copy Both Desc"],
										style = "dropdown",
										width = "normal",
										values = function()
											local c = 0
											CopyBothMessageProfileTable = {}
											if glrHistory ~= nil then
												if glrHistory.Profile ~= nil then
													if glrHistory.Profile.Messages ~= nil then
														if glrHistory.Profile.Messages.Both ~= nil then
															for id, val in pairs(glrHistory.Profile.Messages.Both) do
																if id ~= FullPlayerName then
																	table.insert(CopyBothMessageProfileTable, id)
																	c = c + 1
																end
															end
														end
													end
												end
											end
											if c >= 1 then
												sort(CopyBothMessageProfileTable)
												return CopyBothMessageProfileTable
											else
												table.insert(CopyBothMessageProfileTable, L["GLR_Error_No_Entries_Found"])
												return CopyBothMessageProfileTable
											end
										end,
										get = function()
											return CopyBothMessageProfileName
										end,
										set = function(_, key)
											CopyBothMessageProfileName = key
											local name = CopyBothMessageProfileTable[key]
											for i = 1, #glrHistory.Profile.Messages.Both[name] - 1 do
												glrHistory.Profile.Messages.Both[FullPlayerName][i] = glrHistory.Profile.Messages.Both[name][i]
												glrCharacter.Data.Messages.GuildAlerts.Both[i] = glrHistory.Profile.Messages.Both[name][i]
											end
										end,
									},
								},
							},
						},
					},
				},
			},
			messageOptions = {
				order = 5,
				type = "group",
				name = L["Configuration Panel Message Tab"],
				childGroups = "tab",
				args = {
					GuildAlertMessageTab_Execute_ShowFormats = {
						order = 0,
						type = "execute",
						name = function(info) if ShowFormats then return "Hide Formats" else return "Show Formats" end end,
						desc = "Show/Hide the available Formats",
						func = function()
							if ShowFormats then
								ShowFormats = false
							else
								ShowFormats = true
							end
						end,
					},
					GuildAlertMessageTab_List_ShowFormatType = {
						order = 1,
						type = "select",
						name = "Format Type",
						values = function()
							local t = { [1] = L["Lottery"], [2] = L["Raffle"] }
							return t
						end,
						get = function()
							return ShowFormatNumber
						end,
						set = function(_, key)
							ShowFormatNumber = key
						end,
					},
					GuildAlertMessageTab_Spacer = {
						order = 2,
						type = "description",
						name = "",
						width = "full",
					},
					GuildAlertMessageTab_List_ShowFormats = {
						order = 3,
						type = "description",
						name = function(info)
							local msg = ""
							if ShowFormatNumber == 1 then
								msg = string.gsub(L["Configuration Panel Message Tab Formats"], "%%state", string.lower(L["Lottery"]))
								msg = msg .. L["Configuration Panel Message Tab Formats Part 2"]
							else
								msg = string.gsub(L["Configuration Panel Message Tab Formats"], "%%state", string.lower(L["Raffle"]))
							end
							return msg
						end,
						hidden = function(self) if ShowFormats then return false else return true end end,
					},
					GuildAlertMessageTab_Lottery = {
						order = 4,
						type = "group",
						name = L["Configuration Panel Message Tab Guild Alert (L) Config"],
						childGroups = "tree",
						args = {
							GuildAlert_Lottery_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Message Tab Guild Alert (L) Name"],
							},
							GuildAlert_Lottery_Enable = {
								order = 2,
								type = "toggle",
								name = L["Configuration Panel Message Enable Lottery"],
								width = "full",
								get = function()
									return glrCharacter.Data.Messages.GuildAlerts.Lottery[8]
								end,
								set = function(info, val)
									glrCharacter.Data.Messages.GuildAlerts.Lottery[8] = val
								end,
							},
							GuildAlert_Lottery_Settings = {
								order = 3,
								type = "group",
								name = L["Configuration Panel Message Settings"],
								desc = L["Configuration Panel Message Settings Desc"],
								childGroups = "tab",
								args = {
									GuildAlert_Lottery_1 = {
										order = 1,
										type = "input",
										name = L["Configuration Panel Message One"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[1]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[1] = val
											end
										end,
									},
									GuildAlert_Lottery_2 = {
										order = 2,
										type = "input",
										name = L["Configuration Panel Message Two"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[2]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[2] = val
											end
										end,
									},
									GuildAlert_Lottery_3 = {
										order = 3,
										type = "input",
										name = L["Configuration Panel Message Three"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[3]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[3] = val
											end
										end,
									},
									GuildAlert_Lottery_4 = {
										order = 4,
										type = "input",
										name = L["Configuration Panel Message Four"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[4]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[4] = val
											end
										end,
									},
									GuildAlert_Lottery_5 = {
										order = 5,
										type = "input",
										name = L["Configuration Panel Message Five"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[5]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[5] = val
											end
										end,
									},
									GuildAlert_Lottery_6 = {
										order = 6,
										type = "input",
										name = L["Configuration Panel Message Six"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[6]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[6] = val
											end
										end,
									},
									GuildAlert_Lottery_7 = {
										order = 7,
										type = "input",
										name = L["Configuration Panel Message Seven"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Lottery[7]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Lottery[7] = val
											end
										end,
									},
								},
							},
							GuildAlert_Lottery_Preview = {
								order = 4,
								type = "group",
								name = L["Configuration Panel Preview"],
								childGroups = "tab",
								args = {
									GuildAlert_Lottery_Preview_Header = {
										order = 0,
										type = "header",
										name = L["Configuration Panel Message Preview"],
									},
									GuildAlert_Lottery_Preview_1 = {
										order = 1,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[1], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[1], "Lottery") end,
									},
									GuildAlert_Lottery_Preview_2 = {
										order = 2,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[2], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[2], "Lottery") end,
									},
									GuildAlert_Lottery_Preview_3 = {
										order = 3,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[3], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[3], "Lottery") end,
									},
									GuildAlert_Lottery_Preview_4 = {
										order = 4,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[4], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[4], "Lottery") end,
									},
									GuildAlert_Lottery_Preview_5 = {
										order = 5,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[5], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[5], "Lottery") end,
									},
									GuildAlert_Lottery_Preview_6 = {
										order = 6,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[6], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[6], "Lottery") end,
									},
									GuildAlert_Lottery_Preview_7 = {
										order = 7,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[7], "Lottery") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Lottery[7], "Lottery") end,
									},
								},
							},
						},
					},
					GuildAlertMessageTab_Raffle = {
						order = 5,
						type = "group",
						name = L["Configuration Panel Message Tab Guild Alert (R) Config"],
						childGroups = "tree",
						args = {
							GuildAlert_Raffle_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Message Tab Guild Alert (R) Name"],
							},
							GuildAlert_Raffle_Enable = {
								order = 2,
								type = "toggle",
								name = L["Configuration Panel Message Enable Raffle"],
								width = "full",
								get = function()
									return glrCharacter.Data.Messages.GuildAlerts.Raffle[9]
								end,
								set = function(info, val)
									glrCharacter.Data.Messages.GuildAlerts.Raffle[9] = val
								end,
							},
							GuildAlert_Raffle_Settings = {
								order = 3,
								type = "group",
								name = L["Configuration Panel Message Settings"],
								desc = L["Configuration Panel Message Settings Desc"],
								childGroups = "tab",
								args = {
									GuildAlert_Raffle_1 = {
										order = 1,
										type = "input",
										name = L["Configuration Panel Message One"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[1]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[1] = val
											end
										end,
									},
									GuildAlert_Raffle_2 = {
										order = 2,
										type = "input",
										name = L["Configuration Panel Message Two"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[2]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[2] = val
											end
										end,
									},
									GuildAlert_Raffle_3 = {
										order = 3,
										type = "input",
										name = L["Configuration Panel Message Three"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[3]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[3] = val
											end
										end,
									},
									GuildAlert_Raffle_4 = {
										order = 4,
										type = "input",
										name = L["Configuration Panel Message Four"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[4]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[4] = val
											end
										end,
									},
									GuildAlert_Raffle_5 = {
										order = 5,
										type = "input",
										name = L["Configuration Panel Message Five"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[5]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[5] = val
											end
										end,
									},
									GuildAlert_Raffle_6 = {
										order = 6,
										type = "input",
										name = L["Configuration Panel Message Six"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[6]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[6] = val
											end
										end,
									},
									GuildAlert_Raffle_7 = {
										order = 7,
										type = "input",
										name = L["Configuration Panel Message Seven"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[7]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[7] = val
											end
										end,
									},
									GuildAlert_Raffle_8 = {
										order = 8,
										type = "input",
										name = L["Configuration Panel Message Eight"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Raffle[8]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Raffle[8] = val
											end
										end,
									},
								},
							},
							GuildAlert_Raffle_Preview = {
								order = 4,
								type = "group",
								name = L["Configuration Panel Preview"],
								childGroups = "tab",
								args = {
									GuildAlert_Raffle_Preview_Header = {
										order = 0,
										type = "header",
										name = L["Configuration Panel Message Preview"],
									},
									GuildAlert_Raffle_Preview_1 = {
										order = 1,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[1], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[1], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_2 = {
										order = 2,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[2], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[2], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_3 = {
										order = 3,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[3], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[3], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_4 = {
										order = 4,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[4], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[4], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_5 = {
										order = 5,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[5], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[5], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_6 = {
										order = 6,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[6], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[6], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_7 = {
										order = 7,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[7], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[7], "Raffle") end,
									},
									GuildAlert_Raffle_Preview_8 = {
										order = 8,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[8], "Raffle") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Raffle[8], "Raffle") end,
									},
								},
							},
						},
					},
					GuildAlertMessageTab_Both = {
						order = 6,
						type = "group",
						name = L["Configuration Panel Message Tab Guild Alert (B) Config"],
						childGroups = "tree",
						args = {
							GuildAlert_Both_Header = {
								order = 1,
								type = "header",
								name = L["Configuration Panel Message Tab Guild Alert (B) Name"],
							},
							GuildAlert_Both_Enable = {
								order = 2,
								type = "toggle",
								name = L["Configuration Panel Message Enable Both"],
								desc = L["Configuration Panel Message Enable Both Desc"],
								width = "full",
								get = function()
									if not glrCharacter.Data.Messages.GuildAlerts.Lottery[8] then
										glrCharacter.Data.Messages.GuildAlerts.Both[12] = false
									end
									if not glrCharacter.Data.Messages.GuildAlerts.Raffle[9] then
										glrCharacter.Data.Messages.GuildAlerts.Both[12] = false
									end
									return glrCharacter.Data.Messages.GuildAlerts.Both[12]
								end,
								set = function(info, val)
									local lottery = glrCharacter.Data.Messages.GuildAlerts.Lottery[8]
									local raffle = glrCharacter.Data.Messages.GuildAlerts.Raffle[8]
									if lottery and raffle then
										glrCharacter.Data.Messages.GuildAlerts.Both[12] = val
									end
								end,
							},
							GuildAlert_Both_Settings = {
								order = 3,
								type = "group",
								name = L["Configuration Panel Message Settings"],
								desc = L["Configuration Panel Message Settings Desc"],
								childGroups = "tab",
								args = {
									GuildAlert_Both_1 = {
										order = 1,
										type = "input",
										name = L["Configuration Panel Message One"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[1]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[1] = val
											end
										end,
									},
									GuildAlert_Both_2 = {
										order = 2,
										type = "input",
										name = L["Configuration Panel Message Two"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[2]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[2] = val
											end
										end,
									},
									GuildAlert_Both_3 = {
										order = 3,
										type = "input",
										name = L["Configuration Panel Message Three"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[3]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[3] = val
											end
										end,
									},
									GuildAlert_Both_4 = {
										order = 4,
										type = "input",
										name = L["Configuration Panel Message Four"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[4]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[4] = val
											end
										end,
									},
									GuildAlert_Both_5 = {
										order = 5,
										type = "input",
										name = L["Configuration Panel Message Five"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[5]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[5] = val
											end
										end,
									},
									GuildAlert_Both_6 = {
										order = 6,
										type = "input",
										name = L["Configuration Panel Message Six"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[6]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[6] = val
											end
										end,
									},
									GuildAlert_Both_7 = {
										order = 7,
										type = "input",
										name = L["Configuration Panel Message Seven"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[7]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[7] = val
											end
										end,
									},
									GuildAlert_Both_8 = {
										order = 8,
										type = "input",
										name = L["Configuration Panel Message Eight"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[8]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[8] = val
											end
										end,
									},
									GuildAlert_Both_9 = {
										order = 9,
										type = "input",
										name = L["Configuration Panel Message Nine"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[9]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[9] = val
											end
										end,
									},
									GuildAlert_Both_10 = {
										order = 10,
										type = "input",
										name = L["Configuration Panel Message Ten"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[10]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[10] = val
											end
										end,
									},
									GuildAlert_Both_11 = {
										order = 11,
										type = "input",
										name = L["Configuration Panel Message Eleven"],
										width = "full",
										get = function()
											return glrCharacter.Data.Messages.GuildAlerts.Both[11]
										end,
										set = function(info, val)
											local text = string.len(val)
											if text > 255 then
												GLR:Print(L["Configuration Panel Message Too Long"])
											else
												glrCharacter.Data.Messages.GuildAlerts.Both[11] = val
											end
										end,
									},
								},
							},
							GuildAlert_Both_Preview = {
								order = 4,
								type = "group",
								name = L["Configuration Panel Preview"],
								childGroups = "tab",
								args = {
									GuildAlert_Both_Preview_Header = {
										order = 0,
										type = "header",
										name = L["Configuration Panel Message Preview"],
									},
									GuildAlert_Both_Preview_1 = {
										order = 1,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[1], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[1], "Both") end,
									},
									GuildAlert_Both_Preview_2 = {
										order = 2,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[2], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[2], "Both") end,
									},
									GuildAlert_Both_Preview_3 = {
										order = 3,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[3], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[3], "Both") end,
									},
									GuildAlert_Both_Preview_4 = {
										order = 4,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[4], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[4], "Both") end,
									},
									GuildAlert_Both_Preview_5 = {
										order = 5,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[5], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[5], "Both") end,
									},
									GuildAlert_Both_Preview_6 = {
										order = 6,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[6], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[6], "Both") end,
									},
									GuildAlert_Both_Preview_7 = {
										order = 7,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[7], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[7], "Both") end,
									},
									GuildAlert_Both_Preview_8 = {
										order = 8,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[8], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[8], "Both") end,
									},
									GuildAlert_Both_Preview_9 = {
										order = 9,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[9], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[9], "Both") end,
									},
									GuildAlert_Both_Preview_10 = {
										order = 10,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[10], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[10], "Both") end,
									},
									GuildAlert_Both_Preview_11 = {
										order = 11,
										type = "description",
										hidden = function(self) local msg = PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[11], "Both") if msg == "" then return true else return false end end,
										name = function(info) return PreviewMessage(glrCharacter.Data.Messages.GuildAlerts.Both[11], "Both") end,
									},
								},
							},
						},
					},
				},
			},
			giveawayOptions = {
				order = 6,
				type = "group",
				name = L["Configuration Panel Giveaway Tab"],
				childGroups = "tab",
				args = {
					Giveaway_Select_Event = {
						order = 0,
						type = "select",
						name = L["Giveaway - Select Event"],
						values = function()
							GiveawaySelectEventName = { [1] = L["Lottery"], [2] = L["Raffle"] }
							if not glrCharacter.Data.Settings.CurrentlyActiveLottery then
								for i = 1, #GiveawaySelectEventName do
									if GiveawaySelectEventName[i] == L["Lottery"] then
										table.remove(GiveawaySelectEventName, i)
									end
								end
							end
							if not glrCharacter.Data.Settings.CurrentlyActiveRaffle then
								for i = 1, #GiveawaySelectEventName do
									if GiveawaySelectEventName[i] == L["Raffle"] then
										table.remove(GiveawaySelectEventName, i)
									end
								end
							end
							if not glrCharacter.Data.Settings.CurrentlyActiveLottery and not glrCharacter.Data.Settings.CurrentlyActiveRaffle then
								GiveawaySelectEventName = { [1] = L["Giveaway - No Event Active"] }
								GiveawaySelectEvent = 1
							end
							return GiveawaySelectEventName
						end,
						get = function()
							return GiveawaySelectEvent
						end,
						set = function(_, key)
							GiveawaySelectEvent = key
							GiveawayLastOnlineTableKey = 0
							if glrCharacter.Data.Settings.MultiGuild then GiveawayValueKey = 1 end
							GiveawayMultiGuildKey = 1
							GiveawayConfirm = false
							GiveawayTickets = "0"
							GiveAwayNumber = 0
							GiveawayMultiGuildNames = {}
							GiveawayMultiGuildRankTable = {}
							GiveawayMultiGuildRankSelectTable = {}
						end,
					},
					Giveaway_Settings_Select_Type = {
						order = 1,
						type = "select",
						name = L["Giveaway - Type"],
						desc = L["Giveaway - Type Desc"],
						style = "dropdown",
						width = "normal",
						hidden = function(self) if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true else return false end end,
						values = function()
							return GiveawayValuesTable
						end,
						get = function()
							return GiveawayValueKey
						end,
						set = function(_, key)
							GiveawayValueKey = key
							GiveAwayNumber = 0
							GiveAwayText = L["Giveaway - Names Available"] .. ": " .. tostring(GiveAwayNumber)
							for f, tf in pairs(GLR_EntryTable) do
								for g, tg in pairs(GLR_EntryTable[f]) do
									for i = 1, #GiveawayMultiGuildRankSelectTable[f][g] do
										GiveawayMultiGuildRankSelectTable[f][g][i] = false
									end
									for r, tr in pairs(GLR_EntryTable[f][g]) do
										GLR_EntryTable[f][g][r].State = false
										GLR_EntryCheckTable[f][g][r].State = false
										GLR_EntryCheckTable[f][g][r].Check = false
										GLR_EntryCheckTable[f][g][r].Entered = false
									end
								end
							end
							if GLR_FinalEntryTable[1] ~= nil then
								GLR_FinalEntryTable = {}
								GetValidEntries()
							end
						end,
					},
					Giveaway_Settings_Select_Online = {
						order = 2,
						type = "select",
						name = L["Giveaway - Online"],
						desc = L["Giveaway - Online Desc"],
						style = "dropdown",
						width = "normal",
						hidden = function(self) if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true else return false end end,
						values = function()
							GiveawayLastOnlineTable = {
								[0] = L["Giveaway - Everyone"],
								[1] = L["Giveaway - Currently Online"],
								[2] = L["Giveaway - 7 Days"],
								[3] = L["Giveaway - 14 Days"],
								[4] = L["Giveaway - 21 Days"],
								[5] = L["Giveaway - 28 Days"],
							}
							if glrCharacter.Data.Settings.MultiGuild then table.remove(GiveawayLastOnlineTable, 1) end
							return GiveawayLastOnlineTable
						end,
						get = function()
							return GiveawayLastOnlineTableKey
						end,
						set = function(_, key)
							GiveawayLastOnlineTableKey = key
							GiveAwayNumber = 0
							GiveAwayText = L["Giveaway - Names Available"] .. ": " .. tostring(GiveAwayNumber)
							for f, tf in pairs(GLR_EntryTable) do
								for g, tg in pairs(GLR_EntryTable[f]) do
									for i = 1, #GiveawayMultiGuildRankSelectTable[f][g] do
										GiveawayMultiGuildRankSelectTable[f][g][i] = false
									end
									for r, tr in pairs(GLR_EntryTable[f][g]) do
										GLR_EntryTable[f][g][r].State = false
										GLR_EntryCheckTable[f][g][r].State = false
										GLR_EntryCheckTable[f][g][r].Check = false
										GLR_EntryCheckTable[f][g][r].Entered = false
									end
								end
							end
							if GLR_FinalEntryTable[1] ~= nil then
								GLR_FinalEntryTable = {}
								GetValidEntries()
							end
						end,
					},
					Giveaway_Input_Amount = {
						order = 3,
						type = "input",
						name = L["Giveaway - Tickets"],
						desc = function(info) return string.gsub(L["Giveaway - Tickets Desc"], "%%t", GiveawayTickets) end,
						width = "normal",
						hidden = function(self) if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true else return false end end,
						get = function()
							return GiveawayTickets
						end,
						set = function(info, val)
							local EventType = ""
							if GiveawaySelectEventName[GiveawaySelectEvent] == L["Lottery"] then
								EventType = "Lottery"
							elseif GiveawaySelectEventName[GiveawaySelectEvent] == L["Raffle"] then
								EventType = "Raffle"
							end
							local text = tonumber(val)
							if text == nil then
								text = "0"
							else
								if text >= 0 then
									if string.find(val, '%.') then
										text = string.sub(val, 1, string.find(val, '%.') - 1)
									else
										text = tostring(text)
									end
								else
									text = "0"
								end
							end
							local MaxTickets = tonumber(glrCharacter.Event[EventType].MaxTickets)
							if tonumber(val) ~= nil and MaxTickets ~= nil then
								if tonumber(val) > MaxTickets then
									text = tostring(MaxTickets)
								end
							end
							GiveawayTickets = text
						end,
					},
					Giveaway_Settings_Toggle_Confirm = {
						order = 4,
						type = "toggle",
						name = L["Confirm Action"],
						width = "normal",
						hidden = function(self) if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] or GiveawayTickets == "0" or GiveAwayNumber == 0 then return true else return false end end,
						get = function()
							return GiveawayConfirm
						end,
						set = function(info, val)
							GiveawayConfirm = val
						end,
					},
					Giveaway_Settings_Execute = {
						order = 5,
						type = "execute",
						name = L["Giveaway - Start"],
						desc = L["Giveaway - Start Desc"],
						width = "normal",
						hidden = function(self) if GiveawayConfirm then return false else return true end end,
						func = function()
							GiveAwayTotal = GiveAwayNumber
							if GiveawaySelectEventName[GiveawaySelectEvent] == L["Lottery"] then
								GiveEveryoneTickets(GiveawayTickets, "Lottery")
							elseif GiveawaySelectEventName[GiveawaySelectEvent] == L["Raffle"] then
								GiveEveryoneTickets(GiveawayTickets, "Raffle")
							end
							GetMultiGuildTables()
							GiveawayConfirm = false
							GiveawayTickets = "0"
							GiveawayLastOnlineTableKey = 0
							GiveawayValueKey = 1
						end,
					},
					Giveaway_Settings_Spacer_1 = {
						order = 6,
						type = "description",
						name = "",
						width = "full",
					},
					Giveaway_Settings_Desc_AvailableEntries = {
						order = 7,
						type = "description",
						hidden = function(self) if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true else return false end end,
						name = function(info)
							GetValidEntries()
							return GiveAwayText
						end,
						width = "full",
					},
					Giveaway_Settings_Spacer_2 = {
						order = 8,
						type = "description",
						name = "",
						width = "full",
					},
					Giveaway_Settings_Select_Faction = {
						order = 9,
						type = "select",
						name = "Select Faction",
						style = "dropdown",
						width = "normal",
						hidden = function(self)	if GiveawayValueKey == 2 and glrCharacter.Data.Settings.MultiGuild and glrCharacter.Data.Settings.CrossFactionEvents then return false else return true end end,
						values = function()
							return GiveawayMultiGuildFactionTable
						end,
						get = function()
							return GiveawayMultiGuildFactionKey
						end,
						set = function(_, key)
							GiveawayMultiGuildFaction = GiveawayMultiGuildFactionTable[key]
							GiveawayMultiGuildFactionKey = key
							GiveawayMultiGuildKey = 1
							GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
						end,
					},
					Giveaway_Settings_Select_Guild_MultiGuild = {
						order = 10,
						type = "select",
						name = L["Giveaway - Select Guild"],
						desc = L["Giveaway - Select Guild Desc"],
						style = "dropdown",
						width = "normal",
						hidden = function(self)	if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true elseif GiveawayValueKey == 2 and glrCharacter.Data.Settings.MultiGuild then return false else return true end end,
						values = function()
							local name = GetMultiGuildList()
							if not glrCharacter.Data.Settings.CrossFactionEvents and not CheckMultiGuildFaction then
								local faction, _ = UnitFactionGroup("PLAYER")								
								for i = 1, #GiveawayMultiGuildFactionTable do
									if GiveawayMultiGuildFactionTable[i] == faction then
										GiveawayMultiGuildFactionKey = i
										GiveawayMultiGuildFaction = GiveawayMultiGuildFactionTable[GiveawayMultiGuildFactionKey]
										GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
										CheckMultiGuildFaction = true
										break
									end
								end
							end
							return name[GiveawayMultiGuildFaction]
						end,
						get = function()
							return GiveawayMultiGuildKey
						end,
						set = function(_, key)	
							GiveawayMultiGuildKey = key
							GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
						end,
					},
					Giveaway_Settings_Select_Ranks_MultiGuild = {
						order = 11,
						type = "multiselect",
						name = L["Giveaway - Select Rank"],
						desc = L["Giveaway - Select Ranks Desc"],
						hidden = function(self)	if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true elseif GiveawayValueKey == 2 and glrCharacter.Data.Settings.MultiGuild then return false else return true end end,
						values = function()
							GuildRoster()
							local names = GetMultiGuildList()
							for t, v in pairs(glrHistory.GuildRanks) do
								if GiveawayMultiGuildRankTable[t] == nil then GiveawayMultiGuildRankTable[t] = {} end
								if GiveawayMultiGuildRankSelectTable[t] == nil then GiveawayMultiGuildRankSelectTable[t] = {} end
								for j = 1, #names[t] do
									local name = names[t][j]
									if glrHistory.GuildRanks[t][name] ~= nil then
										for i = 1, #glrHistory.GuildRanks[t][name] do
											if GiveawayMultiGuildRankTable[t][name] == nil then
												GiveawayMultiGuildRankTable[t][name] = {}
											end
											if GiveawayMultiGuildRankTable[t][name][i] == nil then
												GiveawayMultiGuildRankTable[t][name][i] = glrHistory.GuildRanks[t][name][i]
												if GiveawayMultiGuildRankSelectTable[t][name] == nil then
													GiveawayMultiGuildRankSelectTable[t][name] = {}
												end
												GiveawayMultiGuildRankSelectTable[t][name][i] = false
											end
										end
									end
								end
							end
							return GiveawayMultiGuildRankTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]]
						end,
						get = function(info, key)
							return GiveawayMultiGuildRankSelectTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key]
						end,
						set = function(info, key, value)
							GLR_EntryTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][GiveawayMultiGuildRankTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key]].State = value
							if value then
								GLR_EntryCheckTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][GiveawayMultiGuildRankTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key]].State = value
							end
							GiveawayMultiGuildRankSelectTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key] = value
						end,
					},
					Giveaway_Settings_Select_Ranks_SingleGuild = {
						order = 12,
						type = "multiselect",
						name = L["Giveaway - Select Rank"],
						desc = L["Giveaway - Select Ranks Desc"],
						hidden = function(self)	if GiveawaySelectEventName[GiveawaySelectEvent] == L["Giveaway - No Event Active"] then return true elseif GiveawayValueKey == 2 and not glrCharacter.Data.Settings.MultiGuild then return false else return true end end,
						values = function()
							GuildRoster()
							local faction, _ = UnitFactionGroup("PLAYER")
							local guild, _, _, _ = GetGuildInfo("PLAYER")
							local names = GetMultiGuildList()
							if GiveawayMultiGuildFaction ~= faction then
								for i = 1, #GiveawayMultiGuildFactionTable do
									if GiveawayMultiGuildFactionTable[i] == faction then
										GiveawayMultiGuildFactionKey = i
										GiveawayMultiGuildFaction = GiveawayMultiGuildFactionTable[GiveawayMultiGuildFactionKey]
										break
									end
								end
							end
							if GiveawayMultiGuildName ~= guild then
								for i = 1, #GiveawayMultiGuildNames[GiveawayMultiGuildFaction] do
									if GiveawayMultiGuildNames[GiveawayMultiGuildFaction][i] == guild then
										GiveawayMultiGuildKey = i
										GiveawayMultiGuildName = GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]
										break
									end
								end
							end
							if GiveawayMultiGuildRankTable[faction] == nil then GiveawayMultiGuildRankTable[faction] = {} end
							if GiveawayMultiGuildRankSelectTable[faction] == nil then GiveawayMultiGuildRankSelectTable[faction] = {} end
							for j = 1, #names[faction] do
								local name = names[faction][j]
								if glrHistory.GuildRanks[faction][name] ~= nil then
									for i = 1, #glrHistory.GuildRanks[faction][name] do
										if GiveawayMultiGuildRankTable[faction][name] == nil then
											GiveawayMultiGuildRankTable[faction][name] = {}
										end
										if GiveawayMultiGuildRankTable[faction][name][i] == nil then
											GiveawayMultiGuildRankTable[faction][name][i] = glrHistory.GuildRanks[faction][name][i]
											if GiveawayMultiGuildRankSelectTable[faction][name] == nil then
												GiveawayMultiGuildRankSelectTable[faction][name] = {}
											end
											GiveawayMultiGuildRankSelectTable[faction][name][i] = false
										end
									end
								end
							end
							return GiveawayMultiGuildRankTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]]
						end,
						get = function(info, key)
							return GiveawayMultiGuildRankSelectTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key]
						end,
						set = function(info, key, value)
							GLR_EntryTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][GiveawayMultiGuildRankTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key]].State = value
							if value then
								GLR_EntryCheckTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][GiveawayMultiGuildRankTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key]].State = value
							end
							GiveawayMultiGuildRankSelectTable[GiveawayMultiGuildFaction][GiveawayMultiGuildNames[GiveawayMultiGuildFaction][GiveawayMultiGuildKey]][key] = value
						end,
					},
				},
			}
		},
	}
	return options
end